<?php
/* ****************** clase ubicada en prestashop_1_4_5_1/admin99/tab  ****************************** */
include_once(PS_ADMIN_DIR.'/../classes/AdminTab.php');
/* **** y añado mi clase generica para tratar/gestionar los parametros de puntos ******** */
require_once(PS_ADMIN_DIR.'/../classes/PuntsGestion.php');
require_once(PS_ADMIN_DIR.'/../classes/PuntsPromoParam.php');

class AdminPunts extends AdminTab
{
  /** @var array profiles list */
  private $profilesArray = array();

  public function __construct()
	{
	//echo "---->probanmdooooooooooo construct ".date('Y-m-d H:i:s');

	 	global $cookie;

	 	$this->table = 'punts_promo_esp_param';
		$this->className = 'PuntsPromoParam';   /* debe existir en /classes */
	 	$this->lang = false;
	 	$this->edit = true;
	 	$this->delete = true;
 		/* $this->_select = 'pl.`name` AS profile';
		$this->_join = 'LEFT JOIN `'._DB_PREFIX_.'profile` p ON a.`id_profile` = p.`id_profile`
		LEFT JOIN `'._DB_PREFIX_.'profile_lang` pl ON (pl.`id_profile` = p.`id_profile` AND pl.`id_lang` = '.(int)($cookie->id_lang).')'; */
		//$this->_select = 'pl.`name` AS profile';

		$profiles = Profile::getProfiles((int)($cookie->id_lang));
		if (!$profiles)
			$this->_errors[] = Tools::displayError('No profile');
		else
			foreach ($profiles AS $profile)
				$this->profilesArray[$profile['name']] = $profile['name'];

		/* a) crear cabeceras y campos para mostrar la tabla de promociones especiales */
		//$this->optionTitle = $this->l('Parámetros generales de Gestion de Puntos para Promociones Especiales');
		//echo '<h2>Parámetros generales de Gestion de Puntos para Promociones Especiales</h2>';
		echo '<h2>'. $this->l('Parámetros generales de Gestion de Puntos para Promociones Especiales') .'</h2>';
		$this->fieldsDisplay = array(
		'id_punts_promo_esp_param' => array('title' => $this->l('ID Promo'), 'align' => 'center', 'width' => 20),
		'id_tipo_promo_esp_param' => array('title' => $this->l('tipo Promo'), 'align' => 'center', 'width' => 20),
		'ltDescrPromo' => array('title' => $this->l('Descripcion Promo'), 'align' => 'center', 'width' => 80),
		'fcIni' => array('title' => $this->l('Fecha Ini Promo'), 'align' => 'center', 'width' => 40),
		'fcFin' => array('title' => $this->l('Fecha Fin Promo')   , 'align' => 'center', 'width' => 40),
		'cdTipoValorControl' => array('title' => $this->l('Tipo Valor Ctrl')    , 'align' => 'center', 'width' => 20),
		'ltValorControlNUM'  => array('title' => $this->l('Val. Num Ctrl'), 'align' => 'center', 'width' => 40),
		'ltValorControlSTR'  => array('title' => $this->l('Val. Texto Ctrl')   , 'align' => 'center', 'width' => 50),
		'ltValorControlFEC'  => array('title' => $this->l('Val. Fecha Ctrl')   , 'align' => 'center', 'width' => 40),
		'nuPto_CLI1' => array('title' => $this->l('Ptos Clie tipo 1'), 'align' => 'center', 'width' => 20),
		'nuPto_CLI2' => array('title' => $this->l('Ptos Clie tipo 2'), 'align' => 'center', 'width' => 20),
		'nuPto_CLI3' => array('title' => $this->l('Ptos Clie tipo 3'), 'align' => 'center', 'width' => 20),
		'nuDiasCaduc_Pto_CLI1' => array('title' => $this->l('Dias Caduc Clie tipo 1'), 'align' => 'center', 'width' => 20),
		'nuDiasCaduc_Pto_CLI2' => array('title' => $this->l('Dias Caduc Clie tipo 2'), 'align' => 'center', 'width' => 20),
		'nuDiasCaduc_Pto_CLI3' => array('title' => $this->l('Dias Caduc Clie tipo 3'), 'align' => 'center', 'width' => 20),
		/* 'fcUpd' => array('title' => $this->l('fecha update datos'), 'align' => 'center', 'width' => 40), */
		);
		


		/* b) mostrar resto de parametros generales de puntos */

		$this->optionTitle = $this->l('Parámetros generales de Gestion de Puntos');
		$this->_fieldsOptions = array(
		//$this->_fieldsGeneral = array(
			 'CONV_PU_EU' => array(  'title' => $this->l('Conversion de 1 Punt a €:')
						,'desc'  => $this->l('Equivalencia para la conversion de 1 Punt a euros (usar punto (.) como separador decimal)') 
						///,'cast' => 'intval'
						,'size' => 10
						,'type' => 'decimal'
						//,'default' => 333
						)			
			,'LIM_MAX_CLI1' => array( 'title' => $this->l('Lim.max. de compra cl.1:')
						,'desc'  => $this->l('Limite maximo de compra para cliente tipo 1-consumidor ocasional') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'LIM_MAX_CLI2' => array( 'title' => $this->l('Lim.max. de compra cl.2:')
						,'desc'  => $this->l('Limite maximo de compra para cliente tipo 2-consumidor habitual') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'LIM_MAX_CLI3' => array( 'title' => $this->l('Lim.max. de compra cl.3:')
						,'desc'  => $this->l('Limite maximo de compra para cliente tipo 3-superconsumidor') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)

			,'PTO_POR_COMPRA_CLI1' => array( 'title' => $this->l('Ptos por € de compra cl.1:')
						,'desc'  => $this->l('Puntos por euro de compra para cliente tipo 1-consumidor ocasional') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'PTO_POR_COMPRA_CLI2' => array( 'title' => $this->l('Ptos por € de compra cl.2:')
						,'desc'  => $this->l('Puntos por euro de compra para cliente tipo 2-consumidor habitual') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'PTO_POR_COMPRA_CLI3' => array( 'title' => $this->l('Ptos por € de compra cl.3:')
						,'desc'  => $this->l('Puntos por euro de compra para cliente tipo 3-superconsumidor') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'CADUC_PTO_POR_COMPRA_CLI1' => array( 'title' => $this->l('Caduc. ptos por compra cl.1:')
						,'desc'  => $this->l('Caducidad en dias de los puntos por euro de compra para cliente tipo 1-consumidor ocasional') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'CADUC_PTO_POR_COMPRA_CLI2' => array( 'title' => $this->l('Caduc. ptos por compra cl.2:')
						,'desc'  => $this->l('Caducidad en dias de los puntos por euro de compra para cliente tipo 2-consumidor habitual') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'CADUC_PTO_POR_COMPRA_CLI3' => array( 'title' => $this->l('Caduc. ptos por compra cl.3:')
						,'desc'  => $this->l('Caducidad en dias de los puntos por euro de compra para cliente tipo 3-superconsumidor') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)


			,'PTO_POR_APADR_APADR' => array( 'title' => $this->l('Ptos por apadrinado:')
						,'desc'  => $this->l('Puntos por euro de compra para el apadrinado') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'PTO_POR_APADR_PADR_CLI1' => array( 'title' => $this->l('Ptos por padrino cl.1:')
						,'desc'  => $this->l('Puntos por euro de compra para el padrino tipo 1-consumidor ocasional') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'PTO_POR_APADR_PADR_CLI2' => array( 'title' => $this->l('Ptos por padrino cl.2:')
						,'desc'  => $this->l('Puntos por euro de compra para el padrino tipo 2-consumidor habitual') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'PTO_POR_APADR_PADR_CLI3' => array( 'title' => $this->l('Ptos por padrino cl.3:')
						,'desc'  => $this->l('Puntos por euro de compra para el padrino tipo 3-superconsumidor') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'LIMIT_ECONOMIC_POR_APADRINAM' => array( 'title' => $this->l('Limite en € por apadrinamiento:')
						,'desc'  => $this->l('Limite economico por asignacion de puntos por apadrinamiento') 
						//,'cast' => 'intval'
						,'size' => 10
						,'type' => 'decimal'
						)
			,'CADUC_PTO_POR_APADR_APADR' => array( 'title' => $this->l('Caduc. ptos por apadrinado:')
						,'desc'  => $this->l('Caducidad en dias de los puntos por euro de compra para el apadrinado') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'CADUC_PTO_POR_APADR_PADR_CLI1' => array( 'title' => $this->l('Caduc. ptos por padrino cl.1:')
						,'desc'  => $this->l('Caducidad en dias de los puntos por euro de compra para el padrino tipo 1-consumidor ocasional') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'CADUC_PTO_POR_APADR_PADR_CLI2' => array( 'title' => $this->l('Caduc. ptos por padrino cl.2:')
						,'desc'  => $this->l('Caducidad en dias de los puntos por euro de compra para el padrino tipo 2-consumidor habitual') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'CADUC_PTO_POR_APADR_PADR_CLI3' => array( 'title' => $this->l('Caduc. ptos por padrino cl.3:')
						,'desc'  => $this->l('Caducidad en dias de los puntos por euro de compra para el padrino tipo 3-superconsumidor') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'PTO_POR_COMENT_CLI1' => array( 'title' => $this->l('Ptos por comentario cl.1:')
						,'desc'  => $this->l('Puntos comentario para cliente tipo 1-consumidor ocasional') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'PTO_POR_COMENT_CLI2' => array( 'title' => $this->l('Ptos por comentario cl.2:')
						,'desc'  => $this->l('Puntos comentario para cliente tipo 2-consumidor habitual') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'PTO_POR_COMENT_CLI3' => array( 'title' => $this->l('Ptos por comentario cl.3:')
						,'desc'  => $this->l('Puntos comentario para cliente tipo 3-superconsumidor') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'LIMIT_ECONOMIC_POR_COMENT_CLI1' => array( 'title' => $this->l('Lim.max. por comentario cl.1:')
						,'desc'  => $this->l('Limite economico por asignacion de puntos por comentario de cliente tipo 1-consumidor ocasional') 
						//,'cast' => 'intval'
						,'size' => 10
						,'type' => 'decimal(20,6)'
						)
			,'LIMIT_ECONOMIC_POR_COMENT_CLI2' => array( 'title' => $this->l('Lim.max. por comentario cl.2:')
						,'desc'  => $this->l('Limite economico por asignacion de puntos por comentario de cliente tipo 2-consumidor habitual') 
						//,'cast' => 'intval'
						,'size' => 10
						,'type' => 'decimal(20,6)'
						)
			,'LIMIT_ECONOMIC_POR_COMENT_CLI3' => array( 'title' => $this->l('Lim.max. por comentario cl.3:')
						,'desc'  => $this->l('Limite economico por asignacion de puntos por comentario de cliente tipo 3-superconsumidor') 
						//,'cast' => 'intval'
						,'size' => 10
						,'type' => 'decimal(20,6)'
						)
			,'CADUC_PTO_POR_COMENT_CLI1' => array( 'title' => $this->l('Caduc. ptos por coment.cl.1:')
						,'desc'  => $this->l('Caducidad en dias de los puntos por comentario para cliente tipo 1-consumidor ocasional') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'CADUC_PTO_POR_COMENT_CLI2' => array( 'title' => $this->l('Caduc. ptos por coment.cl.2:')
						,'desc'  => $this->l('Caducidad en dias de los puntos por comentario para cliente tipo 2-consumidor habitual') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'CADUC_PTO_POR_COMENT_CLI3' => array( 'title' => $this->l('Caduc. ptos por coment.cl.3:')
						,'desc'  => $this->l('Caducidad en dias de los puntos por comentario para cliente tipo 3-superconsumidor') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)

			,'PTO_POR_ANIVERS_CLI1' => array( 'title' => $this->l('Ptos por aniversario cl.1:')
						,'desc'  => $this->l('Puntos por aniversario para cliente tipo 1-consumidor ocasional') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'PTO_POR_ANIVERS_CLI2' => array( 'title' => $this->l('Ptos por aniversario cl.2:')
						,'desc'  => $this->l('Puntos por aniversario para cliente tipo 2-consumidor habitual') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'PTO_POR_ANIVERS_CLI3' => array( 'title' => $this->l('Ptos por aniversario cl.3:')
						,'desc'  => $this->l('Puntos por aniversario para cliente tipo 3-superconsumidor') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'CADUC_PTO_POR_ANIVERS_CLI1' => array( 'title' => $this->l('Caduc. ptos por anivers.cl.1:')
						,'desc'  => $this->l('Caducidad en dias de los puntos por aniversario para cliente tipo 1-consumidor ocasional') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'CADUC_PTO_POR_ANIVERS_CLI2' => array( 'title' => $this->l('Caduc. ptos por anivers.cl.2:')
						,'desc'  => $this->l('Caducidad en dias de los puntos por aniversario para cliente tipo 2-consumidor habitual') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)
			,'CADUC_PTO_POR_ANIVERS_CLI3' => array( 'title' => $this->l('Caduc. ptos por anivers.cl.3:')
						,'desc'  => $this->l('Caducidad en dias de los puntos por aniversario para cliente tipo 3-superconsumidor') 
						,'cast' => 'intval'
						,'size' => 10
						,'type' => 'integer'
						)

			,'DEVOL_GRATIS_CLI1' => array( 'title' => $this->l('Devoluc.gratis.cl.1:')
						,'desc'  => $this->l('Devolución gratuita para cliente tipo 1-consumidor ocasional') 
						,'size' => 1
						,'type' => 'text'
						)
			,'DEVOL_GRATIS_CLI2' => array( 'title' => $this->l('Devoluc.gratis.cl.2:')
						,'desc'  => $this->l('Devolución gratuita para cliente tipo 2-consumidor habitual') 
						,'size' => 1
						,'type' => 'text'
						)
			,'DEVOL_GRATIS_CLI3' => array( 'title' => $this->l('Devoluc.gratis.cl.3:')
						,'desc'  => $this->l('Devolución gratuita para cliente tipo 3-superconsumidor') 
						,'size' => 1
						,'type' => 'text'
						)

			);


		// llamada al constructor
		parent::__construct();

	}



  public function displayForm($isMainTab = true)
	{
		global $currentIndex, $cookie;
		parent::displayForm();

		if (!($obj = $this->loadObject(true)))
			return;
		$profiles = Profile::getProfiles((int)($cookie->id_lang));

		echo '<script type="text/javascript" src="'._PS_JS_DIR_.'/jquery/jquery-colorpicker.js"></script>
		 	 <script type="text/javascript">
				var employeePage = true;
		 	 </script>';


		//preparacion previa de los option select del tipo de promocion
		$miSQL = "SELECT id_tipo_promo_esp_param, ltDescrTipoPromo FROM ps_tipo_promo_esp_param ";
		$miCadenaOptionValue = "";
		// bucle para recorrer los tipos de promociones existentes
		$regDevuelto = Db::getInstance()->executeS($miSQL);
		foreach ($regDevuelto as $fila)
			{
			////echo "<br>---> TIPO PROMOC.ESP num.". $fila['id_tipo_promo_esp_param']."-". $fila['ltDescrTipoPromo'];
			$miCadenaOptionValue = $miCadenaOptionValue 
			     ."<option value=".$fila['id_tipo_promo_esp_param']." "
			     .($this->getFieldValue($obj,'id_tipo_promo_esp_param') == $fila['id_tipo_promo_esp_param'] ? ' selected="selected"' : ' ')
			     ."> ".$fila['ltDescrTipoPromo'] ." </option> ";
			};



		// formulario para la modificacion de un registro de la tabla de promociones especiales
		echo '<form action="'.$currentIndex.'&submitAdd'.$this->table.'=1&token='.$this->token.((int)$this->tabAccess['view'] ? '' : '&updatepuntspromoesp&id_punts_promo_esp_param='.(int)$obj->id)
		.'" method="post" enctype="multipart/form-data" autocomplete="off">'
		.($obj->id ? '<input type="hidden" name="id_'.$this->table.'" value="'.$obj->id.'" />' : '')
		.' '.((int)$this->tabAccess['view'] ? '' : '<input type="hidden" name="back" value="'.$currentIndex.'&token='.$this->token.'&updatepuntspromoesp&id_punts_promo_esp_param='.(int)$obj->id.'" />').'

			<!-- /***** lista de campos de la tabla a modificar *****/ -->
			<fieldset class="width3"> 
				<legend><img src="../img/admin/nav-user.gif" />'.$this->l('punts_promo_esp_param').'</legend>
				
				<label>'.$this->l('Tipo de promocion:').' </label>
				<div class="margin-form">
					<select name="id_tipo_promo_esp_param">
						'. $miCadenaOptionValue .' 
					</select> <sup>*</sup>
				</div><div class="clear">&nbsp;</div>

				<label>'.$this->l('Descripcion de la promocion:').' </label>
				<div class="margin-form">
					<input type="text" size="50" name="ltDescrPromo" 
					  value="'.htmlentities($this->getFieldValue($obj, 'ltDescrPromo'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup>*</sup>
				</div><div class="clear">&nbsp;</div>

				<label>'.$this->l('Fecha de inicio de la promocion:').' </label>
				<div class="margin-form">
					<input type="text" size="10" name="fcIni" 
					  value="'.htmlentities($this->getFieldValue($obj, 'fcIni'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup>*</sup>
				</div><div class="clear">&nbsp;</div>				
				<label>'.$this->l('Fecha de fin de la promocion:').' </label>
				<div class="margin-form">
					<input type="text" size="10" name="fcFin" 
					  value="'.htmlentities($this->getFieldValue($obj, 'fcFin'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup>*</sup>
				</div><div class="clear">&nbsp;</div>


				<label>'.$this->l('Tipo de valor/dato a controlar en la promocion (NUM/STR/FEC):').' </label>
				<div class="margin-form">
					<select name="cdTipoValorControl">  
						<option value="NUM" '
							.($this->getFieldValue($obj,'cdTipoValorControl') == "NUM" ? ' selected="selected"' : ' ')
							.'> NUMerico </option>
						<option value="STR" '
							.($this->getFieldValue($obj,'cdTipoValorControl') == "STR" ? ' selected="selected"' : ' ')
							.'> Cadena (STRing) </option>
						<option value="FEC" '
							.($this->getFieldValue($obj,'cdTipoValorControl') == "FEC" ? ' selected="selected"' : ' ')
							.'> FECha </option>
					</select> <sup>*</sup>
				</div><div class="clear">&nbsp;</div>


				<label>'.$this->l('Valor/dato de tipo NUMerico a controlar en la promocion:').' </label>
				<div class="margin-form">
					<input type="text" size="20" name="ltValorControlNUM" 
					  value="'.htmlentities($this->getFieldValue($obj, 'ltValorControlNUM'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup></sup>
				</div><div class="clear">&nbsp;</div>
				<label>'.$this->l('Valor/dato de tipo STRing a controlar en la promocion:').' </label>
				<div class="margin-form">
					<input type="text" size="60" name="ltValorControlSTR" 
					  value="'.htmlentities($this->getFieldValue($obj, 'ltValorControlSTR'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup></sup>
				</div><div class="clear">&nbsp;</div>
				<label>'.$this->l('Valor/dato de tipo FECha a controlar en la promocion:').' </label>
				<div class="margin-form">
					<input type="text" size="10" name="ltValorControlFEC" 
					  value="'.htmlentities($this->getFieldValue($obj, 'ltValorControlFEC'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup> formato fecha AAAA-MM-DD</sup>
				</div><div class="clear">&nbsp;</div>

				<label>'.$this->l('Puntos por euro de compra para cliente tipo 1-consumidor ocasional:').' </label>
				<div class="margin-form">
					<input type="text" size="20" name="nuPto_CLI1" 
					  value="'.htmlentities($this->getFieldValue($obj, 'nuPto_CLI1'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup>*</sup>
				</div><div class="clear">&nbsp;</div>
				<label>'.$this->l('Puntos por euro de compra para cliente tipo 2-consumidor habitual:').' </label>
				<div class="margin-form">
					<input type="text" size="20" name="nuPto_CLI2" 
					  value="'.htmlentities($this->getFieldValue($obj, 'nuPto_CLI2'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup>*</sup>
				</div><div class="clear">&nbsp;</div>
				<label>'.$this->l('Puntos por euro de compra para cliente tipo 3-superconsumidor:').' </label>
				<div class="margin-form">
					<input type="text" size="20" name="nuPto_CLI3" 
					  value="'.htmlentities($this->getFieldValue($obj, 'nuPto_CLI3'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup>*</sup>
				</div><div class="clear">&nbsp;</div>

				<label>'.$this->l('Caducidad en dias de los puntos por euro de compra para cliente tipo 1-consumidor ocasional:').' </label>
				<div class="margin-form">
					<input type="text" size="20" name="nuDiasCaduc_Pto_CLI1" 
					  value="'.htmlentities($this->getFieldValue($obj, 'nuDiasCaduc_Pto_CLI1'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup>*</sup>
				</div><div class="clear">&nbsp;</div>
				<label>'.$this->l('Caducidad en dias de los puntos por euro de compra para cliente tipo 2-consumidor habitual:').' </label>
				<div class="margin-form">
					<input type="text" size="20" name="nuDiasCaduc_Pto_CLI2" 
					  value="'.htmlentities($this->getFieldValue($obj, 'nuDiasCaduc_Pto_CLI2'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup>*</sup>
				</div><div class="clear">&nbsp;</div>
				<label>'.$this->l('Caducidad en dias de los puntos por euro de compra para cliente tipo 3-superconsumidor:').' </label>
				<div class="margin-form">
					<input type="text" size="20" name="nuDiasCaduc_Pto_CLI3" 
					  value="'.htmlentities($this->getFieldValue($obj, 'nuDiasCaduc_Pto_CLI3'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup>*</sup>
				</div><div class="clear">&nbsp;</div> ';

		//boton de guardar
		echo '<div class="clear">&nbsp;</div>
				<center>
					<input type="submit" value="'.$this->l('   Save   ').'" name="submitAdd'.$this->table.'" class="button" />
				</center><div class="clear">&nbsp;</div>
				<div class="small"><sup>*</sup> '.$this->l('Required field').'</div>
			</fieldset>
		</form>';
	}



public function postProcess()
	{

		global $cookie;


		if (Tools::isSubmit('deletepuntspromoesp') OR Tools::isSubmit('status') OR Tools::isSubmit('statuspuntspromoesp'))
		{
			if ($cookie->id_punts_promo_esp_param == Tools::getValue('id_punts_promo_esp_param'))
			{
				$this->_errors[] = Tools::displayError('You cannot disable or delete your own account.');
				return false;
			}
			/* debe existir la clase en /classes como una clase core */
			$PuntsPromoParam = new PuntsPromoParam(Tools::getValue('id_punts_promo_esp_param'));  
			if ($PuntsPromoParam->isLastAdmin())
			{
					$this->_errors[] = Tools::displayError('You cannot disable or delete the last administrator account.');
					return false;
			}
		}
		elseif (Tools::isSubmit('submitAddpuntspromoesp'))
		{
			/* debe existir la clase en /classes como una clase core */
			$PuntsPromoParam = new PuntsPromoParam((int)Tools::getValue('id_punts_promo_esp_param')); 
		}

		return parent::postProcess();
	}

}
