<?php
/* ****************** clase ubicada en prestashop_1_4_5_1/admin99/tab  ****************************** */
include_once(PS_ADMIN_DIR.'/../classes/AdminTab.php');
/* **** y añado mi clase generica para tratar/gestionar los parametros de tipo de promociones especiales ******** */
require_once(PS_ADMIN_DIR.'/../classes/TipoPromoEspParam.php');


class AdminTipoPromoEsp extends AdminTab
{
  /** @var array profiles list */
  private $profilesArray = array();


public function __construct()
	{
		global $cookie;

	 	$this->table = 'tipo_promo_esp_param';
		$this->className = 'TipoPromoEspParam';   /* debe existir en /classes */
	 	$this->lang = false;
	 	$this->edit = true;
	 	$this->delete = true;

		$profiles = Profile::getProfiles((int)($cookie->id_lang));
		if (!$profiles)
			$this->_errors[] = Tools::displayError('No profile');
		else
			foreach ($profiles AS $profile)
				$this->profilesArray[$profile['name']] = $profile['name'];


		/* a) crear cabeceras y campos para mostrar la tabla de tipos de promociones especiales */
		///echo '<h2>Tipos de Promociones Especiales</h2>';
		echo '<h2>'.  $this->l('Tipos de Promociones Especiales') .'</h2>';
		$this->fieldsDisplay = array(
		'id_tipo_promo_esp_param' => array('title' => $this->l('Tipo Promo'), 'align' => 'center', 'width' => 20),
		'ltDescrTipoPromo' => array('title' => $this->l('Descripcion Tipo Promo'), 'align' => 'center', 'width' => 80),
		/* 'fcUpd' => array('title' => $this->l('fecha update datos'), 'align' => 'center', 'width' => 40), */
		);
		
		// llamada al constructor
		parent::__construct();

	}



  public function displayForm($isMainTab = true)
	{
		global $currentIndex, $cookie;
		parent::displayForm();

		if (!($obj = $this->loadObject(true)))
			return;
		$profiles = Profile::getProfiles((int)($cookie->id_lang));

		echo '<script type="text/javascript" src="'._PS_JS_DIR_.'/jquery/jquery-colorpicker.js"></script>
		 	 <script type="text/javascript">
				var employeePage = true;
		 	 </script>';
		

		// formulario para la modificacion de un registro de la tabla 
		echo '<form action="'.$currentIndex.'&submitAdd'.$this->table.'=1&token='.$this->token.((int)$this->tabAccess['view'] ? '' : '&updatetipopromoesp&id_tipo_promo_esp_param='.(int)$obj->id)
		.'" method="post" enctype="multipart/form-data" autocomplete="off">'
		.($obj->id ? '<input type="hidden" name="id_'.$this->table.'" value="'.$obj->id.'" />' : '')
		.' '.((int)$this->tabAccess['view'] ? '' : '<input type="hidden" name="back" value="'.$currentIndex.'&token='.$this->token.'&updatetipopromoesp&id_tipo_promo_esp_param='.(int)$obj->id.'" />').'

			<!- /***** lista de campos de la tabla a modificar *****/ -->
			<fieldset class="width3"> 
				<legend><img src="../img/admin/nav-user.gif" />'.$this->l('tipo_promo_esp_param').'</legend>
				
				<label>'.$this->l('Descripcion de la promocion especial:').' </label>
				<div class="margin-form">
					<input type="text" size="50" name="ltDescrTipoPromo" 
					  value="'.htmlentities($this->getFieldValue($obj, 'ltDescrTipoPromo'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup>*</sup>
				</div><div class="clear">&nbsp;</div>

				<div class="clear">&nbsp;</div> ';

		//boton de guardar
		echo '<div class="clear">&nbsp;</div>
				<center>
					<input type="submit" value="'.$this->l('   Save   ').'" name="submitAdd'.$this->table.'" class="button" />
				</center><div class="clear">&nbsp;</div>
				<div class="small"><sup>*</sup> '.$this->l('Required field').'</div>
			</fieldset>
		</form>';
	}



public function postProcess()
	{

		global $cookie;

		if (Tools::isSubmit('deletetipopromoesp') OR Tools::isSubmit('status') OR Tools::isSubmit('statustipopromoesp'))
		{
			if ($cookie->id_tipo_promo_esp_param == Tools::getValue('id_tipo_promo_esp_param'))
			{
				$this->_errors[] = Tools::displayError('You cannot disable or delete your own account.');
				return false;
			}

			/* debe existir la clase en /classes como una clase core */
			$TipoPromoEspParam = new TipoPromoEspParam(Tools::getValue('id_tipo_promo_esp_param'));  
			if ($TipoPromoEspParam->isLastAdmin())
			{
					$this->_errors[] = Tools::displayError('You cannot disable or delete the last administrator account.');
					return false;
			}
		}
		elseif (Tools::isSubmit('submitAddtipopromoesp'))
		{
			/* debe existir la clase en /classes como una clase core */
			$TipoPromoEspParam = new TipoPromoEspParam((int)Tools::getValue('id_tipo_promo_esp_param')); 			
		}

		return parent::postProcess();
	}

}
