<?php
/*
* 2013 Jesus Sanchis Ortiz
*
* NOTICE OF LICENSE
*
* This source file is subject to the OSL 3.0 license 
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/OSL-3.0
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future.
*
*  @author Jesus Sanchis Ortiz <jesanor@uoc.edu>
*  @copyright  2013 Jesus Sanchis Ortiz
*  @date 30/05/2013
*  @version  Release: $Revision: 1.0 $
*  @license   http://opensource.org/licenses/OSL-3.0  Open Software License (OSL 3.0)
*/


/* ****************** clase ubicada en prestashop_1_4_5_1/classes  ****************************** */


//habilitar el reporting de errores de php
//error_reporting(E_ALL);
//ini_set("display_errors", 1);


//require_once(PS_ADMIN_DIR.'/../classes/Configuration.php');	---> Da error al llamarse desde  /modules/blockuserinfo/blockuserinfo.php
require_once('Configuration.php');	//asi OK
require_once('Mail.php');		//asi OK




////////class PuntsGestionCore extends ObjectModel
////////class PuntsGestion extends ObjectModelCore
class PuntsGestion extends ObjectModel   //asi es como funciona OK hasta ahora
{
	public 		$id;

	/* vars de la tabla ps_punts_clie (excepto la usada como clave: id_ps_punts_clie) */
	public   	$id_customer;
	public   	$cdTipo_clie;
	public   	$fcObtencionPtos;
	public   	$cdTipoObtencionPtos;
	public   	$cdSubTipoObtencionPtos;
	public   	$id_order;
	public   	$nuPtos;
	public   	$nuDiasCaduc_Pto;
	public   	$inPtosCanjeados;
	public   	$fcPtosCanjeados;
	public   	$inPtosDevueltos;
	public   	$fcPtosDevueltos;
	public   	$ltDescrDevueltos;
	public   	$id_customer_relac;
	public   	$id_comment;
	public   	$fcUpd;

 	////protected 	$fieldsRequired = array('lastname', 'firstname', 'email', 'passwd', 'id_profile', 'id_lang');


	protected 	$table = 'ps_punts_clie';  /* tabla */
	protected 	$identifier = 'id_ps_punts_clie';   /* clave de la tabla */


	protected	$webserviceParameters = array(
			'fields' => array(
				'id_customer' => array('sqlId' => 'id_customer', 'xlink_resource' => 'customers'),
				'cdTipo_clie' => array('sqlId' => 'cdTipo_clie'),
				'fcObtencionPtos' => array('sqlId' => 'fcObtencionPtos'),
				'cdTipoObtencionPtos' => array('sqlId' => 'cdTipoObtencionPtos'),
				'cdSubTipoObtencionPtos' => array('sqlId' => 'cdSubTipoObtencionPtos'),
				'id_order' => array('sqlId' => 'id_order'),
				'nuPtos' => array('sqlId' => 'nuPtos'),
				'nuDiasCaduc_Pto' => array('sqlId' => 'nuDiasCaduc_Pto'),
				'inPtosCanjeados' => array('sqlId' => 'inPtosCanjeados'),
				'fcPtosCanjeados' => array('sqlId' => 'fcPtosCanjeados'),
				'inPtosDevueltos' => array('sqlId' => 'inPtosDevueltos'),
				'fcPtosDevueltos' => array('sqlId' => 'fcPtosDevueltos'),
				'ltDescrDevueltos' => array('sqlId' => 'ltDescrDevueltos'),
				'id_customer_relac' => array('sqlId' => 'id_customer_relac'),
				'id_comment' => array('sqlId' => 'id_comment'),
				'fcUpd' => array('sqlId' => 'fcUpd')
				)
			);



	// ------------------------------------------------------------------------------------------------------------------------

	public	function getFields()
	{
	 	//parent::validateFields();

		$fields['id_customer'] = (int)pSQL($this->id_customer);
	   	$fields['cdTipo_clie'] = (int)pSQL($this->cdTipo_clie);
	   	$fields['fcObtencionPtos'] = pSQL($this->fcObtencionPtos);
	   	$fields['cdTipoObtencionPtos']    = (int)pSQL($this->cdTipoObtencionPtos);
	   	$fields['cdSubTipoObtencionPtos'] = (int)pSQL($this->cdSubTipoObtencionPtos);
	   	$fields['id_order'] = (int)pSQL($this->id_order);
	   	$fields['nuPtos'] = (int)pSQL($this->nuPtos);
	   	$fields['nuDiasCaduc_Pto'] = (int)pSQL($this->nuDiasCaduc_Pto);
	   	$fields['inPtosCanjeados'] = pSQL($this->inPtosCanjeados);
	   	$fields['fcPtosCanjeados']  = pSQL($this->fcPtosCanjedos);
	   	$fields['inPtosDevueltos'] = pSQL($this->inPtosDevueltos);
	   	$fields['fcPtosDevueltos'] = pSQL($this->fcPtosDevueltos);
	   	$fields['ltDescrDevueltos'] = pSQL($this->ltDescrDevueltos);
	   	$fields['id_customer_relac'] = pSQL($this->id_customer_relac);
	   	$fields['id_comment'] = pSQL($this->id_comment);
		if (empty($this->fcUpd))
			$this->fcUpd = date('Y-m-d 00:00:00');

		return $fields;
	}


	// ------------------------------------------------------------------------------------------------------------------------

	/** devuelve el numero total de puntos de un cliente **/
	public function getPtosByCli($id_customer,$idTipoConsulta)
	{
		static $miSQL;
		static $nuPtosCli;
		//Tools::displayAsDeprecated();

		/* tipo de consulta = 1: puntos canjeables (no devueltos) y no caducados de un cliente*/
		if ( ($idTipoConsulta == 1) || is_null($idTipoConsulta) )
			{
			$miSQL1 = "SELECT SUM(nuPtos) valorParam, COUNT(*) nuOrdenes ";
			$miSQL2 = "FROM "._DB_PREFIX_."punts_clie  t ";
			$miSQL3 = "WHERE id_customer = ". $id_customer ." "; 
			/* $miSQL4 = "  AND inPtosCanjeados = 'N' AND inPtosDevueltos = 'N' ";  --> el indicador de ptos devueltos es solo 
			orientativo, dado que en las devoluciones MANUALMENTE en backoffice se descuentan los puntos => no debe considerarse */
			$miSQL4 = "  AND inPtosCanjeados = 'N' ";   
			$miSQL5 = "  AND (fcObtencionPtos + INTERVAL nuDiasCaduc_Pto DAY) > CURDATE()  "; 
			$miSQL6 = " ORDER BY 1 ";
			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5." ".$miSQL6;
			} ;

		/* tipo de consulta = 2: puntos canjeables o canjeados, caducados o no, pero NO devueltos de un cliente*/
		if ($idTipoConsulta == 2)  
			{
			$miSQL1 = "SELECT SUM(nuPtos) valorParam, COUNT(*) nuOrdenes ";
			$miSQL2 = "FROM "._DB_PREFIX_."punts_clie  t ";
			$miSQL3 = "WHERE id_customer = ". $id_customer ." "; 
			/* $miSQL4 = "  AND inPtosDevueltos = 'N' ";  --> el indicador de ptos devueltos es solo 
			orientativo, dado que en las devoluciones MANUALMENTE en backoffice se descuentan los puntos => no debe considerarse */
			$miSQL4 = " ";
			$miSQL5 = " ORDER BY 1 ";
			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5;
			} ;

		/* tipo de consulta = 3: puntos canjeables o no (pero no devueltos) de tipo apadrinado de un cliente*/
		if ($idTipoConsulta == 3)  
			{
			$miSQL1 = "SELECT SUM(nuPtos) valorParam, COUNT(*) nuOrdenes ";
			$miSQL2 = "FROM "._DB_PREFIX_."punts_clie  t ";
			$miSQL3 = "WHERE id_customer = ". $id_customer ." "; 
			$miSQL4 = "  AND cdTipoObtencionPtos = 2 AND cdSubTipoObtencionPtos = 2 ";
			/* $miSQL5 = "  AND inPtosDevueltos = 'N' ";  --> el indicador de ptos devueltos es solo 
			orientativo, dado que en las devoluciones MANUALMENTE en backoffice se descuentan los puntos => no debe considerarse */
			$miSQL5 = " ";
			$miSQL6 = " ORDER BY 1 ";
			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5." ".$miSQL6;
			} ;

		if (is_null($id_customer) || empty($id_customer))
			{
			$nuPtosCli = 0;
			}
		else
			{
			// ejecutar la query
			//return Db::getInstance()->getValue($miSQL);
			//return Db::getInstance()->getRow($miSQL);
			//return Db::getInstance()->ExecuteS($miSQL);
			//echo "<hr><br>--> LA QUERY: ".$miSQL."<br><hr>"; 		
			$miValorParam = Db::getInstance()->getRow($miSQL);
			//control de errores al ejecutar la query
			//if (!$miValorParam) 
			if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
				{
				    //0 filas returned or error
				   $nuPtosCli = 0;
				}
			else
				{
				//echo "<BR>--> RESULTADOS: id_customer ". $id_customer ." con SUM(nuPtos): ". $miValorParam['valorParam'] ."<br>";
				if (is_null($miValorParam['valorParam']))
					{ $nuPtosCli = 0; }
				else 
					{ $nuPtosCli = $miValorParam['valorParam']; };
				}
		};
		return $nuPtosCli;
	}



	// ------------------------------------------------------------------------------------------------------------------------

	/** devuelve los registros (filas de la tabla de puntos) correspondientes a los puntos de un cliente **/
	public function getRegsPtosByCli($id_customer,$idTipoConsulta)
	{
		static $miSQL;
		static $nuPtosCli;
		//Tools::displayAsDeprecated();

		/* tipo de consulta = 1: puntos canjeables (no devueltos) y no caducados de un cliente*/
		if ( ($idTipoConsulta == 1) || is_null($idTipoConsulta) )
			{
			$miSQL1 = "SELECT t.* ";
			$miSQL2 = "FROM "._DB_PREFIX_."punts_clie  t ";
			$miSQL3 = "WHERE id_customer = ". $id_customer ." "; 
			/* $miSQL4 = "  AND inPtosCanjeados = 'N' AND inPtosDevueltos = 'N' ";  --> el indicador de ptos devueltos es solo 
			orientativo, dado que en las devoluciones MANUALMENTE en backoffice se descuentan los puntos => no debe considerarse */
			$miSQL4 = "  AND inPtosCanjeados = 'N' ";   
			$miSQL5 = "  AND (fcObtencionPtos + INTERVAL nuDiasCaduc_Pto DAY) > CURDATE()  "; 
			$miSQL6 = " ORDER BY 1 ";
			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5." ".$miSQL6;
			} ;

		/* tipo de consulta = 2: puntos canjeables o canjeados, caducados o no, pero NO devueltos de un cliente*/
		if ($idTipoConsulta == 2)  
			{
			$miSQL1 = "SELECT t.* ";
			$miSQL2 = "FROM "._DB_PREFIX_."punts_clie  t ";
			$miSQL3 = "WHERE id_customer = ". $id_customer ." "; 
			/* $miSQL4 = "  AND inPtosDevueltos = 'N' ";  --> el indicador de ptos devueltos es solo 
			orientativo, dado que en las devoluciones MANUALMENTE en backoffice se descuentan los puntos => no debe considerarse */
			$miSQL4 = " ";
			$miSQL5 = " ORDER BY 1 ";
			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5;
			} ;

		/* tipo de consulta = 3: puntos canjeables o no (pero no devueltos) de tipo apadrinado de un cliente*/
		if ($idTipoConsulta == 3)  
			{
			$miSQL1 = "SELECT t.* ";
			$miSQL2 = "FROM "._DB_PREFIX_."punts_clie  t ";
			$miSQL3 = "WHERE id_customer = ". $id_customer ." "; 
			$miSQL4 = "  AND cdTipoObtencionPtos = 2 AND cdSubTipoObtencionPtos = 2 ";
			/* $miSQL5 = "  AND inPtosDevueltos = 'N' ";  --> el indicador de ptos devueltos es solo 
			orientativo, dado que en las devoluciones MANUALMENTE en backoffice se descuentan los puntos => no debe considerarse */
			$miSQL5 = " ";
			$miSQL6 = " ORDER BY 1 ";
			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5." ".$miSQL6;
			} ;

		// ejecutar la query
		//echo "<hr><br>--> LA QUERY: ".$miSQL."<br><hr>"; 		
		$miRegPuntos = Db::getInstance()->ExecuteS($miSQL);	// devolucion de las n filas (regs)

		if (!$miRegPuntos)
			{
			//cliente sin regs de puntos. devolver array vacio
			//echo "<br>Cliente sin puntos.";
			//echo this->l('<br>Customer has no points.');
			return array();
			}
		else 
			{
			//comprobacion de datos devueltos (codigo para validacion de pruebas)
			//////echo "<br>MIS regs devueltos para el objeto ". $miRegPuntos ."..............<HR>";
			//foreach ($miRegPuntos as $key => $miReg) 
			//	{
			//	echo "<br>---> id_punts_clie ". $miReg['id_punts_clie'] ." del cliente ". $miReg['id_customer'] 
			//		." tiene ". $miReg['nuPtos'] ." puntos ";
			//	};

			///devolver el array de filas/reistros completo
			return $miRegPuntos;
			};
	}





	// ------------------------------------------------------------------------------------------------------------------------

	/** busca la ultima tipologia por cliente y devuelve el numero total de tipos de cliente segun dicha tipologia **/
	public function getTotalPorTipoClie($id_tipoclie)
	{
		static $miSQL;
		static $nuClientsTipoX;

		$miSQL1 = "SELECT COUNT(DISTINCT id_customer) valorParam ";
		$miSQL2 = "FROM ( SELECT id_customer,MAX(cdTipo_clie) cdTipo_clie_MAX ";
		$miSQL3 = "       FROM "._DB_PREFIX_."punts_clie  t ";
		$miSQL4 = "       GROUP BY id_customer ) tt ";
		$miSQL5 = "WHERE cdTipo_clie_MAX = ". $id_tipoclie ."  "; 
		$miSQL6 = "ORDER BY 1 ";
		$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5." ".$miSQL6;

		$miValorParam = Db::getInstance()->getRow($miSQL);
		//control de errores al ejecutar la query
		//if (!$miValorParam) 
		if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
			{
			$nuClientsTipoX = 0;
			}
		else
			{
			if (is_null($miValorParam['valorParam']))
				{ $nuClientsTipoX = 0; }
			else 
				{ $nuClientsTipoX = $miValorParam['valorParam']; };
			}

		return $nuClientsTipoX;
	}




	// ------------------------------------------------------------------------------------------------------------------------

	/** busca el numero total de clientes **/
	public function getTotalClie()
	{
		static $miSQL;
		static $nuTotalClients;

		$miSQL1 = "SELECT COUNT(DISTINCT id_customer) valorParam ";
		$miSQL2 = "FROM "._DB_PREFIX_."customer  t ";
		$miSQL3 = "ORDER BY 1 ";
		$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3;

		$miValorParam = Db::getInstance()->getRow($miSQL);
		//control de errores al ejecutar la query
		//if (!$miValorParam) 
		if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
			{
			$nuTotalClients = 0;
			}
		else
			{
			if (is_null($miValorParam['valorParam']))
				{ $nuTotalClients = 0; }
			else 
				{ $nuTotalClients = $miValorParam['valorParam']; };
			}

		return $nuTotalClients;
	}




	// ------------------------------------------------------------------------------------------------------------------------

	/** devuelve el valor de un parametro general */
	public function getParamGeneral($id_param)
	{
		static $miSQL;
		static $valorADevolver;
		//Tools::displayAsDeprecated();

		$miSQL1 = "SELECT t.value valorParam ";
		$miSQL2 = "FROM "._DB_PREFIX_."configuration t ";
		$miSQL3 = "WHERE t.name = '". $id_param ."' "; 
		$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3;

		///ejecutar la query solamente si tenemos parametro...
		if (is_null($id_param) || empty($id_param))
			{
			$valorADevolver = 0;
			}
		else 
			{
			$miValorParam = Db::getInstance()->getRow($miSQL);
			//echo "<BR>--> parametro ". $id_param .": ". $miValorParam['valorParam'] ;
			if (is_null($miValorParam['valorParam']))
				{ $valorADevolver = 0; }
			else 
				{ $valorADevolver = $miValorParam['valorParam']; };
			}
		return $valorADevolver;
	}


	// ------------------------------------------------------------------------------------------------------------------------

	/** devuelve el tipo de cliente de un cliente*/
	/* tipo de cliente: 1-ocasional, 2-habitual, 3-superconsumidor */
	public function getTipoCli($id_customer)
	{
		/* tipo de cliente segun su importe anual de compra */
		static $cdTipoCLI;

		
		/* 1.a) primero consultar los parametros necesarios */			
		static $miParam_LIM_MAX_CLI1;
		static $miParam_LIM_MAX_CLI2;
		static $miParam_LIM_MAX_CLI3; 
		$miParam_LIM_MAX_CLI1 = $this->getParamGeneral('LIM_MAX_CLI1');
		$miParam_LIM_MAX_CLI2 = $this->getParamGeneral('LIM_MAX_CLI2');
		$miParam_LIM_MAX_CLI3 = $this->getParamGeneral('LIM_MAX_CLI3');		


		/* 1.b) nota: consultar el tipo de cliente en la tabla ps_orders, pero:
			campo total_products = importe total SIN impuestos de los items de esa orden
			campo total_products_wt = importe total CON impuestos de los items de esa orden
			campo total_paid = importe total CON impuestos + Gastos de envío de los items de esa orden
			campo total_paid_real = importe total CON impuestos + Gastos de envío - Descuento de los items de esa orden
		*/
		static $miSQL;
		//Tools::displayAsDeprecated();
		$miSQL1 = "SELECT SUM(total_paid_real) valorParam ";
		$miSQL2 = "FROM "._DB_PREFIX_."orders t ";
		$miSQL3 = "WHERE t.id_customer = ". $id_customer ." "; 
		$miSQL4 = "  AND t.date_add >= DATE_SUB(NOW(), INTERVAL 1 YEAR) ";  // de los ultimos 12 meses
		$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4;

		///ejecutar la query si tenemos parametro
		if (is_null($id_customer) || empty($id_customer))
			{
			$cdTipoCLI = 1;
			}
		else 
			{
			$miValorParam = Db::getInstance()->getRow($miSQL);
			//control de nulos en getRow
			////if ( !$miValorParam || is_null($miValorParam) || empty($miValorParam) )
			if ( !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
				{
				$cdTipoCLI = 1; // ocasional 
				}
				else
				{
				switch  ($miValorParam['valorParam'])
					{ case ($miValorParam['valorParam'] <= $miParam_LIM_MAX_CLI1):
					     $cdTipoCLI = 1; // ocasional 
					     break;
					  case ($miValorParam['valorParam'] > $miParam_LIM_MAX_CLI1)
					    && ($miValorParam['valorParam'] <= $miParam_LIM_MAX_CLI2):
					     $cdTipoCLI = 2; // habitual 
					     break;
					  case ($miValorParam['valorParam'] > $miParam_LIM_MAX_CLI2):
					     $cdTipoCLI = 3; // superconsumidor  
					     break;
					};
				};
			};
		//echo "<BR>--->id_customer:". $id_customer .",SUM(total_paid_real):". $miValorParam['valorParam'] ." cdTipoCLI:". $cdTipoCLI ."<br>";

		return $cdTipoCLI;
	}



	// ------------------------------------------------------------------------------------------------------------------------

	/** devuelve el ID del cliente a partir de su email (= usuario de conexion) */
	public function getIDCliByEmail($id_email)
	{
		/* tipo de cliente segun su importe anual de compra */
		static $id_cliente;
		static $miSQL;
		//Tools::displayAsDeprecated();
		
		$miSQL1 = "SELECT MAX(id_customer)  valorParam ";
		$miSQL2 = "FROM "._DB_PREFIX_."customer t ";
		$miSQL3 = "WHERE TRIM(LOWER(t.email)) = '". trim(strtolower($id_email)) ."' "; 
		$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3;

		if (is_null($id_email) || empty($id_email))
			{
			$id_cliente = -1;
			}
		else
			{
			//ejecutar la query
			$miValorParam = Db::getInstance()->getRow($miSQL);
			//control de errores
			//if (!$miValorParam) 
			if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
				{
				$id_cliente = 0;
				}
			else
				{
				$id_cliente = $miValorParam['valorParam'];
				};
			///echo "<BR>---> id_email ". $id_email ." con id_customer: ". $id_cliente ." <br>";
			};
		return $id_cliente;
	}




	// ------------------------------------------------------------------------------------------------------------------------

	/** CONSULTA el numero de puntos canjeables de un item si lo comprase el cliente (para incluirlo en la ficha del producto) */
	public function getPtosByCompraByCli($id_customer, $id_order, $importe_order)
	{

		/* tipo de cliente segun su importe anual de compra */
		static $cdTipoCLI;
		

		/* 1.a) primero consultar el tipo de cliente*/		
		$cdTipoCLI = $this->getTipoCli($id_customer);

		/* buscar el parametro de num puntos segun tipo de cliente y de asignacion */
		static $nuPtosAAsignar;
		static $nuDiasCaducPtosAAsignar;
		switch  ($cdTipoCLI)
			{ case 1:
			     //$nuPtosAAsignar =  $this->getParamGeneral('PTO_POR_COMPRA_CLI1');  
			     $nuPtosAAsignar =  floor($importe_order) * $this->getParamGeneral('PTO_POR_COMPRA_CLI1');  
			     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_COMPRA_CLI1');  
			     break;
			  case 2:
			     //$nuPtosAAsignar = $this->getParamGeneral('PTO_POR_COMPRA_CLI2');
			     $nuPtosAAsignar = floor($importe_order) * $this->getParamGeneral('PTO_POR_COMPRA_CLI2');
  			     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_COMPRA_CLI2');  
			     break;
			  case 3:
			     //$nuPtosAAsignar = $this->getParamGeneral('PTO_POR_COMPRA_CLI3');  
			     $nuPtosAAsignar = floor($importe_order) * $this->getParamGeneral('PTO_POR_COMPRA_CLI3');  
			     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_COMPRA_CLI3');  
			     break;
			};
		
		return $nuPtosAAsignar;

	}




	// ------------------------------------------------------------------------------------------------------------------------

	/** asigna el numero de puntos canjeables por orden de compra de un cliente*/
	public function setPtosByCompraByCli($id_customer, $id_order, $importe_order)
	{

		/* tipo de cliente segun su importe anual de compra */
		static $cdTipoCLI;
		

		/* 1.a) primero consultar el tipo de cliente*/		
		$cdTipoCLI = $this->getTipoCli($id_customer);

		/* buscar el parametro de num puntos segun tipo de cliente y de asignacion */
		static $nuPtosAAsignar;
		static $nuDiasCaducPtosAAsignar;
		switch  ($cdTipoCLI)
			{ case 1:
			     //$nuPtosAAsignar =  $this->getParamGeneral('PTO_POR_COMPRA_CLI1');  
			     $nuPtosAAsignar =  floor($importe_order) * $this->getParamGeneral('PTO_POR_COMPRA_CLI1');  
			     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_COMPRA_CLI1');  
			     break;
			  case 2:
			     //$nuPtosAAsignar = $this->getParamGeneral('PTO_POR_COMPRA_CLI2');
			     $nuPtosAAsignar = floor($importe_order) * $this->getParamGeneral('PTO_POR_COMPRA_CLI2');
  			     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_COMPRA_CLI2');  
			     break;
			  case 3:
			     //$nuPtosAAsignar = $this->getParamGeneral('PTO_POR_COMPRA_CLI3');  
			     $nuPtosAAsignar = floor($importe_order) * $this->getParamGeneral('PTO_POR_COMPRA_CLI3');  
			     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_COMPRA_CLI3');  
			     break;
			};
		
		/* 1.b) asignar valores a la clase*/
		$this->id_customer = $id_customer;
		$this->cdTipo_clie = $cdTipoCLI;
		$this->fcObtencionPtos = date('Y-m-d 00:00:00');
		$this->cdTipoObtencionPtos = 1;	// por compra
		$this->cdSubTipoObtencionPtos = 0;
		$this->id_order = $id_order;
		$this->nuPtos = $nuPtosAAsignar;
		$this->nuDiasCaduc_Pto = $nuDiasCaducPtosAAsignar ;
		$this->inPtosCanjeados = 'N';
		$this->fcPtosCanjeados  = NULL;
		$this->inPtosDevueltos = 'N';
		$this->fcPtosDevueltos = NULL;
		$this->ltDescrDevueltos = NULL;
		$this->id_customer_relac = 'NULL';
		$this->id_comment = NULL;
		$this->fcUpd = date('Y-m-d 00:00:00');
		
		/* 1.c) asignar valores a la tabla de gestion de puntos */	
		$miSQL1 = "SELECT max(id_punts_clie) valorParam ";
		$miSQL2 = "FROM  "._DB_PREFIX_."punts_clie  ";
		$miSQL  = $miSQL1." ".$miSQL2;
		$miValorParam = Db::getInstance()->getRow($miSQL);
		//control de errores
		//if (!$miValorParam) 
		if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
			{
			$max_id_punts_clie = 1;
			}
		else
			{
			$max_id_punts_clie = $miValorParam['valorParam'] + 1;
			};
		$this->id = $max_id_punts_clie;

		$miSQL1 = "INSERT INTO "._DB_PREFIX_."punts_clie  ";
		$miSQL2 = " (id_punts_clie, id_customer, cdTipo_clie, fcObtencionPtos, cdTipoObtencionPtos ";
		$miSQL3 = " , cdSubTipoObtencionPtos, id_order, nuPtos, nuDiasCaduc_Pto, inPtosCanjeados, fcPtosCanjedos ";
		$miSQL4 = " , inPtosDevueltos, fcPtosDevueltos, ltDescrDevueltos, id_customer_relac, id_comment, fcUpd ) ";
		$miSQL5 = " VALUES (".$this->id.",".$this->id_customer.",".$this->cdTipo_clie.",'".$this->fcObtencionPtos."' ";
		$miSQL6 = " ,".$this->cdTipoObtencionPtos.",".$this->cdSubTipoObtencionPtos.",".$this->id_order.",".$this->nuPtos.",".$this->nuDiasCaduc_Pto." ";
		$miSQL7 = " ,'".$this->inPtosCanjeados."','".$this->fcPtosCanjeados."','".$this->inPtosDevueltos."','".$this->fcPtosDevueltos."' ";
		$miSQL8 = " ,'".$this->ltDescrDevueltos."',".$this->id_customer_relac.",'".$this->id_comment."','".$this->fcUpd."' ) ";
		$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5." ".$miSQL6." ".$miSQL7." ".$miSQL8;
		Db::getInstance()->execute($miSQL);
		

		return $nuPtosAAsignar;

	}




	// ------------------------------------------------------------------------------------------------------------------------

	/** asigna el numero de puntos canjeables por apadrinamiento (tanto al apadrinado como al padrino) */
	/*  (*)nota: se hace en el momento de la compra realizada por el nuevo cliente (apadrinado) */
	public function setPtosByApadrinamByCli($id_customerNew, $id_order, $id_email_customerPadrino, $importe_order)
	{

		//var a utilizar
		static $cdTipoCLI;
		static $nuPtosAAsignar;
		static $nuPtosAAsignarAlPadrino;
		static $nuPtosAAsignarAlApadrinado;
		static $nuDiasCaducPtosAAsignar;
		static $id_customerPadrino;
		static $importeMax_por_apadrinam;
		

		// 0) primero buscar el id del cliente padrino asociado a su email */
		$id_customerPadrino = $this->getIDCliByEmail( $id_email_customerPadrino);

		//echo "<hr><hr>id_customerNew=".$id_customerNew ."<hr><hr>";
		//echo "<hr><hr>id_email_customerPadrino=".$id_email_customerPadrino ."<hr><hr>";
		//echo "<hr><hr>id_customerPadrino=".$id_customerPadrino ."<hr><hr>";



		/* 1) SOLAMENTE SI EL CLIENTE NUEVO NO TIENE PUNTOS asignados por estar APADRINADO...
		      Y QUE EXISTE LA IDENTIFICACION DEL PADRINO, se puede asignar los puntos a ambos */
		///if (   ($this->getPtosByCli($id_customerNew,3) == 0) && (strlen($id_customerPadrino) >= 0) && $id_customerPadrino >= 0  )
		if (  ($this->getPtosByCli($id_customerNew,3) == 0)  && ($id_customerPadrino >= 0) )
			{

			/* 1.1) GESTION DE LOS PUNTOS DEL NUEVO CLIENTE (APADRINADO) */

			/* 1.1.a) primero consultar el tipo de cliente del nuevo cliente (apadrinado) */		
			$cdTipoCLI = $this->getTipoCli($id_customerNew);
			/* buscar el parametro de num puntos segun tipo de cliente y de asignacion */
			//$nuPtosAAsignar = $this->getParamGeneral('PTO_POR_APADR_APADR');  
			$nuPtosAAsignar = floor($importe_order) * $this->getParamGeneral('PTO_POR_APADR_APADR');  
			$nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_APADR_APADR');  
			$nuPtosAAsignarAlApadrinado = $nuPtosAAsignar;
			$importeMax_por_apadrinam =  $this->getParamGeneral('LIMIT_ECONOMIC_POR_APADRINAM');  

			/* 1.1.b) asignar valores a la clase*/
			$this->id_customer = $id_customerNew;
			$this->cdTipo_clie = $cdTipoCLI;
			$this->fcObtencionPtos = date('Y-m-d 00:00:00');
			$this->cdTipoObtencionPtos = 2;  //por apadrinamiento
			$this->cdSubTipoObtencionPtos = 2; //para el apadrinado
			$this->id_order = $id_order;
			$this->nuPtos = $nuPtosAAsignar;  
			$this->nuDiasCaduc_Pto = $nuDiasCaducPtosAAsignar ;
			$this->inPtosCanjeados = 'N';
			$this->fcPtosCanjeados  = NULL;
			$this->inPtosDevueltos = 'N';
			$this->fcPtosDevueltos = NULL;
			$this->ltDescrDevueltos = NULL;
			if ( strlen($id_customerPadrino) > 0 )
				{
				$this->id_customer_relac = $id_customerPadrino;  /* aqui va el ID del cliente PADRINO en este caso */
				}
			else
				{
				$this->id_customer_relac = 'NULL';  /* aqui va el ID del cliente PADRINO en este caso */
				};
			$this->id_comment = NULL;
			$this->fcUpd = date('Y-m-d 00:00:00');
		
			/* 1.1.c) asignar valores a la tabla de gestion de puntos */	
			$miSQL1 = "SELECT max(id_punts_clie) valorParam ";
			$miSQL2 = "FROM  "._DB_PREFIX_."punts_clie  ";
			$miSQL  = $miSQL1." ".$miSQL2;
			$miValorParam = Db::getInstance()->getRow($miSQL);
			//if (!$miValorParam) 
			if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
				{
				$max_id_punts_clie = 1;
				}
			else	
				{
				$max_id_punts_clie = $miValorParam['valorParam'] + 1;
				};
			$this->id = $max_id_punts_clie;

			$miSQL1 = "INSERT INTO "._DB_PREFIX_."punts_clie  ";
			$miSQL2 = " (id_punts_clie, id_customer, cdTipo_clie, fcObtencionPtos, cdTipoObtencionPtos ";
			$miSQL3 = " , cdSubTipoObtencionPtos, id_order, nuPtos, nuDiasCaduc_Pto, inPtosCanjeados, fcPtosCanjedos ";
			$miSQL4 = " , inPtosDevueltos, fcPtosDevueltos, ltDescrDevueltos, id_customer_relac, id_comment, fcUpd ) ";
			$miSQL5 = " VALUES (".$this->id.",".$this->id_customer.",".$this->cdTipo_clie.",'".$this->fcObtencionPtos."' ";
			$miSQL6 = " ,".$this->cdTipoObtencionPtos.",".$this->cdSubTipoObtencionPtos.",".$this->id_order.",".$this->nuPtos.",".$this->nuDiasCaduc_Pto." ";
			$miSQL7 = " ,'".$this->inPtosCanjeados."','".$this->fcPtosCanjeados."','".$this->inPtosDevueltos."','".$this->fcPtosDevueltos."' ";
			$miSQL8 = " ,'".$this->ltDescrDevueltos."',".$this->id_customer_relac.",'".$this->id_comment."','".$this->fcUpd."' ) ";
			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5." ".$miSQL6." ".$miSQL7." ".$miSQL8;
			Db::getInstance()->execute($miSQL);
		

			//*****************************************************************************************************************
			/* 1.1.d) Enviament de email al APADRINADO per l'assignació de punts per apadrinament */
			//*****************************************************************************************************************

			// obtener datos del cliente 
			$miSQL1 = "SELECT firstname, lastname, email, birthday ";
			$miSQL2 = "FROM  "._DB_PREFIX_."customer  ";
			$miSQL3 = "WHERE id_customer = ". $this->id_customer ." ";
			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3;
			$miValorParam = Db::getInstance()->getRow($miSQL);
			$firstname = $miValorParam['firstname'];
			$lastname = $miValorParam['lastname'];
			$email = $miValorParam['email'];
			$id_email_customerNew = $email;


			//asignacion de valores para el email 
			//$template_name = 'newsletter'; //nombre de plantilla de mail a usar (uso la generica newsletter)
			$template_name = 'newsletter_apa1'; //nombre de plantilla de mail a usar (uso la nueva newsletter_apa1)
			///$id_land = Language::getIdByIso('es');     //Set the language mail template
			$id_lang = 3;     //Set the language mail template
			$subject = 'Asignacion de puntos por apadrinamiento';
			$data = array(
					'{firstname}' => $firstname,
					'{lastname}' => $lastname,
					'{email}' => $email,
					'{shop_name}' => Configuration::get('PS_SHOP_NAME'),
					'{shop_url}' => Configuration::get('PS_SHOP_DOMAIN'),
					'{id_email_customerPadrino}' => $id_email_customerPadrino,
					'{nuPtos}' => $this->nuPtos,
					'{nuDiasCaduc_Pto}' => $this->nuDiasCaduc_Pto,
					/* '{message}' => "Sr./Sra. ".$firstname. " ".$lastname. ", por ser apadrinado por el cliente "
							. $id_email_customerPadrino ." le hemos otorgado ". $this->nuPtos 
							." puntos a su cuenta que podra cambiar por vales de descuento (hasta dentro de "
							.$this->nuDiasCaduc_Pto." dias)."   */
					'{message}' => " " //variable ya no usada directamente (se deja vacia por si alguien la invoca)
				  );
			$fileAttachment = NULL;
			//envio del email			
			$send = Mail::Send($id_lang, $template_name, Mail::l($subject, $id_lang), $data, $email, $firstname.' '.$lastname
					, NULL, NULL, $fileAttachment);
			///if ($send)
			///        echo "<br> OK. Email sent to customer ".$this->id_customer;
			///else
			///        echo "<br> ERROR sending to customer ".$this->id_customer;





			/* 1.2) GESTION DE LOS PUNTOS DEL CLIENTE PADRINO */

			/* 1.2.a) primero consultar el tipo de cliente del padrino */		
			$cdTipoCLI = $this->getTipoCli($id_customerPadrino);
			/* buscar el parametro de num puntos segun tipo de cliente y de asignacion */
			switch  ($cdTipoCLI)
				{ case 1:
				     //$nuPtosAAsignar = $this->getParamGeneral('PTO_POR_APADR_PADR_CLI1');  
				     $nuPtosAAsignar = floor($importe_order) * $this->getParamGeneral('PTO_POR_APADR_PADR_CLI1');  
				     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_APADR_PADR_CLI1');  
				     break;
				  case 2:
				     //$nuPtosAAsignar = $this->getParamGeneral('PTO_POR_APADR_PADR_CLI2');  
				     $nuPtosAAsignar = floor($importe_order) * $this->getParamGeneral('PTO_POR_APADR_PADR_CLI2');  
	  			     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_APADR_PADR_CLI2');  
				     break;
				  case 3:
				     //$nuPtosAAsignar = $this->getParamGeneral('PTO_POR_APADR_PADR_CLI3');  
				     $nuPtosAAsignar = floor($importe_order) * $this->getParamGeneral('PTO_POR_APADR_PADR_CLI3');  
				     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_APADR_PADR_CLI3');  
				     break;
				};

			/* 1.2.b) asignar valores a la clase*/
			$this->id_customer = $id_customerPadrino;
			$this->cdTipo_clie = $cdTipoCLI;
			$this->fcObtencionPtos = date('Y-m-d 00:00:00');
			$this->cdTipoObtencionPtos = 2;  //por apadrinamiento
			$this->cdSubTipoObtencionPtos = 1; //para el padrino
			$this->id_order = $id_order;
			$this->nuPtos = $nuPtosAAsignar;  
			$this->nuDiasCaduc_Pto = $nuDiasCaducPtosAAsignar ;
			$this->inPtosCanjeados = 'N';
			$this->fcPtosCanjeados  = NULL;
			$this->inPtosDevueltos = 'N';
			$this->fcPtosDevueltos = NULL;
			$this->ltDescrDevueltos = NULL;
			$this->id_customer_relac = $id_customerNew;  /* aqui va el ID del cliente APADRINADO en este caso */
			$this->id_comment = NULL;
			$this->fcUpd = date('Y-m-d 00:00:00');

			/* 1.2.c) asignar valores a la tabla de gestion de puntos */	
			$miSQL1 = "SELECT max(id_punts_clie) valorParam ";
			$miSQL2 = "FROM  "._DB_PREFIX_."punts_clie  ";
			$miSQL  = $miSQL1." ".$miSQL2;
			$miValorParam = Db::getInstance()->getRow($miSQL);
			//if (!$miValorParam) 
			if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
				{
				$max_id_punts_clie = 1;
				}
			else
				{
				$max_id_punts_clie = $miValorParam['valorParam'] + 1;
				};
			$this->id = $max_id_punts_clie;

			$miSQL1 = "INSERT INTO "._DB_PREFIX_."punts_clie  ";
			$miSQL2 = " (id_punts_clie, id_customer, cdTipo_clie, fcObtencionPtos, cdTipoObtencionPtos ";
			$miSQL3 = " , cdSubTipoObtencionPtos, id_order, nuPtos, nuDiasCaduc_Pto, inPtosCanjeados, fcPtosCanjedos ";
			$miSQL4 = " , inPtosDevueltos, fcPtosDevueltos, ltDescrDevueltos, id_customer_relac, id_comment, fcUpd ) ";
			$miSQL5 = " VALUES (".$this->id.",".$this->id_customer.",".$this->cdTipo_clie.",'".$this->fcObtencionPtos."' ";
			$miSQL6 = " ,".$this->cdTipoObtencionPtos.",".$this->cdSubTipoObtencionPtos.",".$this->id_order.",".$this->nuPtos.",".$this->nuDiasCaduc_Pto." ";
			$miSQL7 = " ,'".$this->inPtosCanjeados."','".$this->fcPtosCanjeados."','".$this->inPtosDevueltos."','".$this->fcPtosDevueltos."' ";
			$miSQL8 = " ,'".$this->ltDescrDevueltos."',".$this->id_customer_relac.",'".$this->id_comment."','".$this->fcUpd."' ) ";
			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5." ".$miSQL6." ".$miSQL7." ".$miSQL8;
			Db::getInstance()->execute($miSQL);
		


			//*****************************************************************************************************************
			/* 1.2.d) Enviament de email al PADRINO per l'assignació de punts per apadrinament */
			//*****************************************************************************************************************

			// obtener datos del cliente 
			$miSQL1 = "SELECT firstname, lastname, email, birthday ";
			$miSQL2 = "FROM  "._DB_PREFIX_."customer  ";
			$miSQL3 = "WHERE id_customer = ". $this->id_customer ." ";
			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3;
			$miValorParam = Db::getInstance()->getRow($miSQL);
			$firstname = $miValorParam['firstname'];
			$lastname = $miValorParam['lastname'];
			$email = $miValorParam['email'];


			///echo "<HR><HR>--> PROBANDO ENVIO DE EMAIL al PADRINO al cliente ".$this->id_customer ." para el email ". $email ."<HR>";

			//asignacion de valores para el email 
			//$template_name = 'newsletter'; //nombre de plantilla de mail a usar (uso la generica newsletter)
			$template_name = 'newsletter_apa2'; //nombre de plantilla de mail a usar (uso la nueva newsletter_apa2)
			///$id_land = Language::getIdByIso('es');     //Set the language mail template
			$id_lang = 3;     //Set the language mail template
			$subject = 'Asignacion de puntos por apadrinamiento';
			$data = array(
					'{firstname}' => $firstname,
					'{lastname}' => $lastname,
					'{email}' => $email,
					'{shop_name}' => Configuration::get('PS_SHOP_NAME'),
					'{shop_url}' => Configuration::get('PS_SHOP_DOMAIN'),
					'{id_email_customerNew}' => $id_email_customerNew,
					'{nuPtos}' => $this->nuPtos,
					'{nuDiasCaduc_Pto}' => $this->nuDiasCaduc_Pto,
					/* '{message}' => "Sr./Sra. ".$firstname. " ".$lastname. ", por haber apadrinado al cliente "
							. $id_email_customerNew ." le hemos otorgado ". $this->nuPtos 
							." puntos a su cuenta que podra cambiar por vales de descuento (hasta dentro de "
							.$this->nuDiasCaduc_Pto." dias)."   */
					'{message}' => " " //variable ya no usada directamente (se deja vacia por si alguien la invoca)
				  );
			$fileAttachment = NULL;
			//envio del email			
			$send = Mail::Send($id_lang, $template_name, Mail::l($subject, $id_lang), $data, $email, $firstname.' '.$lastname
					, NULL, NULL, $fileAttachment);
			///if ($send)
			///        echo "<br> OK. Email sent to customer ".$this->id_customer;
			///else
			///        echo "<br> ERROR sending to customer ".$this->id_customer;

			}
		else
			{
			/* no se ha encontrado el padrino asociado o cliente ya tiene puntos por apadrinado o no se ha intentado apadrinar */
			$nuPtosAAsignar = 0;
			//a) padrino no encontrado o vacío (no se ha intentado apadrinar			
			//if ( (strlen($id_customerPadrino) == 0) || ($id_customerPadrino == -1 ) )
			//	{
			//	echo "<BR>El cliente padrino ". $id_email_customerPadrino ." no se ha encontrado<BR>";
			//	};
			//b) cliente ya apadrinado
			//El cliente ya tiene puntos por haber sido apadrinado anteriormente => no hacer nada
			//if ( $this->getPtosByCli($id_customerNew,3) > 0 )
			//	{
			//	echo "<BR>El cliente ya tiene puntos por haber sido apadrinado anteriormente por ".$id_customerPadrino .".<BR>";
			//	};
			};


		return $nuPtosAAsignarAlApadrinado;
	}




	// ------------------------------------------------------------------------------------------------------------------------

	/** envia email de invitacion a n apadrinados por parte del padrino */
	/*  (*)nota: se hace desde el apartado correspondiente "Apadrinar" en "Mi Cuenta" del padrino */
	public function sendEmailAApadrinadosByPadrino($id_customerPadrino, $numClieApadrinados, $listaemail_apadrinados )
	{

		//var a utilizar
		static $cdTipoCLI;
		static $nuPtosAAsignar;
		static $nuDiasCaducPtosAAsignar;
		static $nuClientesInvitados;

		//ptos que conseguirá el apadrinado...
		//$nuPtosAAsignar = floor($importe_order) * $this->getParamGeneral('PTO_POR_APADR_APADR');  
		//$nuPtosPorEuroAAsignar =   $this->getParamGeneral('PTO_POR_APADR_APADR');  
		//$nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_APADR_APADR');  
		//es necesaria la invocacion de esta forma para no provocar error
		$nuPtosPorEuroAAsignar =  PuntsGestion::getParamGeneral('PTO_POR_APADR_APADR');  
		$nuDiasCaducPtosAAsignar = PuntsGestion::getParamGeneral('CADUC_PTO_POR_APADR_APADR');  



		//*****************************************************************************************************************
		/* Enviament de email al APADRINADO per part del PADRI invintant-lo a fer compres i ser apadrinat */
		//*****************************************************************************************************************

		// obtener datos del cliente PADRINO
		$miSQL1 = "SELECT firstname, lastname, email, birthday ";
		$miSQL2 = "FROM  "._DB_PREFIX_."customer  ";
		$miSQL3 = "WHERE id_customer = ". $id_customerPadrino ." ";
		$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3;
		$miValorParam = Db::getInstance()->getRow($miSQL);
		$firstname = $miValorParam['firstname'];
		$lastname = $miValorParam['lastname'];
		$emailPadrino = $miValorParam['email'];


		$nuClientesInvitados = 0;
		for ( $i=1; $i <= $numClieApadrinados; $i++) 
			{
			$email = $listaemail_apadrinados[$i];

			//asignacion de valores para el email 
			//$template_name = 'newsletter'; //nombre de plantilla de mail a usar (uso la generica newsletter)
			$template_name = 'newsletter_apa0'; //nombre de plantilla de mail a usar (uso la nueva newsletter_apa0)
			///$id_land = Language::getIdByIso('es');     //Set the language mail template
			$id_lang = 3;     //Set the language mail template
			$subject = 'Asignacion de puntos de bienvenida por apadrinamiento';
			$data = array(
				'{firstname}' => $firstname,
				'{lastname}' => $lastname,
				'{email}' => $email,
				'{shop_name}' => Configuration::get('PS_SHOP_NAME'),
				'{shop_url}' => Configuration::get('PS_SHOP_DOMAIN'),
				'{id_email_customerPadrino}' => $emailPadrino,
				'{nuPtosPorEuroAAsignar}' => $nuPtosPorEuroAAsignar,
				/* '{message}' => $firstname. " ".$lastname. ", le invita a formar parte de Grandes Zapatos."
						." Y para darle la bienvenida le ha regalado ".  $nuPtosPorEuroAAsignar 
						." puntos por cada euro de compra de su primera compra y que podrá canjear"
						." por vales de descuento para compras posteriores."   */
				'{message}' => " " //variable ya no usada directamente (se deja vacia por si alguien la invoca)
				  );
			$fileAttachment = NULL;
			//envio del email			
			$send = Mail::Send($id_lang, $template_name, Mail::l($subject, $id_lang), $data, $email, $firstname.' '.$lastname
					, NULL, NULL, $fileAttachment);
			///if ($send)
			///        echo "<br> OK. Email sent to ".$email;
			///else
			///        echo "<br> ERROR sending to ".$email;

			$nuClientesInvitados = $nuClientesInvitados + 1;
			};


		return $nuClientesInvitados;
	}



	// ------------------------------------------------------------------------------------------------------------------------

	/** asigna el numero de puntos canjeables por comentario realizado por un cliente*/
	public function setPtosByComentCli($id_customer, $id_comment)
	{

		/* tipo de cliente segun su importe anual de compra */
		static $cdTipoCLI;
		

		/* comprobar que a ese cliente y para ese ID de comentario no se le ha asignado ya puntos */	
		$nuVecesAsignPtosComment = 0;
		$miSQL1 = "SELECT COUNT(*) valorParam";
		$miSQL2 = "FROM  "._DB_PREFIX_."punts_clie  ";
		$miSQL3 = "WHERE id_customer = ". $id_customer ." ";
		$miSQL4 = "  AND cdTipoObtencionPtos = '3' ";
		//$miSQL5 = "  AND id_comment = '". $id_comment ."'  ";   // buscar el ID de comentario 
		$miSQL5 = "  AND id_comment = '". substr($id_comment, -255) ."'  ";   /* buscar el ID de comentario, 
										       y limitamos al tamaño maximo del campo id_comment en BBDD */
		$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5;
		$miValorParam = Db::getInstance()->getRow($miSQL);
		$nuVecesAsignPtosComment = $miValorParam['valorParam'];

		static $nuPtosAAsignar;


		/* asignar valores a la tabla de gestion de puntos (si no los tiene asignados ya) */
		if ( $nuVecesAsignPtosComment == 0 )	
			{

			/* 1.a) primero consultar el tipo de cliente*/		
			$cdTipoCLI = $this->getTipoCli($id_customer);

			/* buscar el parametro de num puntos segun tipo de cliente y de asignacion */
			static $nuDiasCaducPtosAAsignar;
			static $importeMax_por_apadrinam;
			switch  ($cdTipoCLI)
				{ case 1:
				     $nuPtosAAsignar = $this->getParamGeneral('PTO_POR_COMENT_CLI1');  
				     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_COMENT_CLI1');  
				     $importeMax_por_apadrinam = $this->getParamGeneral('LIMIT_ECONOMIC_POR_COMENT_CLI1');  
				     break;
				  case 2:
				     $nuPtosAAsignar = $this->getParamGeneral('PTO_POR_COMENT_CLI2');
	  			     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_COMENT_CLI2');
	  			     $importeMax_por_apadrinam = $this->getParamGeneral('LIMIT_ECONOMIC_POR_COMENT_CLI2');  
				     break;
				  case 3:
				     $nuPtosAAsignar = $this->getParamGeneral('PTO_POR_COMENT_CLI3');  
				     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_COMENT_CLI3');  
				     $importeMax_por_apadrinam = $this->getParamGeneral('LIMIT_ECONOMIC_POR_COMENT_CLI3');  
				     break;
				};
		
			/* 1.b) asignar valores a la clase*/
			$this->id_customer = $id_customer;
			$this->cdTipo_clie = $cdTipoCLI;
			$this->fcObtencionPtos = date('Y-m-d 00:00:00');
			$this->cdTipoObtencionPtos = 3;	// por comentario
			$this->cdSubTipoObtencionPtos = 0;
			$this->id_order = 0;
			$this->nuPtos = $nuPtosAAsignar;
			$this->nuDiasCaduc_Pto = $nuDiasCaducPtosAAsignar ;
			$this->inPtosCanjeados = 'N';
			$this->fcPtosCanjeados  = NULL;
			$this->inPtosDevueltos = 'N';
			$this->fcPtosDevueltos = NULL;
			$this->ltDescrDevueltos = NULL;
			$this->id_customer_relac = 'NULL';
			//$this->id_comment = $id_comment;
			$this->id_comment = substr($id_comment, -255);  //limitamos al tamaño maximo del campo id_comment en BBDD
			$this->fcUpd = date('Y-m-d 00:00:00');
		
			/* 1.c) asignar valores a la tabla de gestion de puntos */	
			$miSQL1 = "SELECT max(id_punts_clie) valorParam ";
			$miSQL2 = "FROM  "._DB_PREFIX_."punts_clie  ";
			$miSQL  = $miSQL1." ".$miSQL2;
			$miValorParam = Db::getInstance()->getRow($miSQL);
			//if (!$miValorParam) 
			if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
				{
				$max_id_punts_clie = 1;
				}
			else
				{
				$max_id_punts_clie = $miValorParam['valorParam'] + 1;
				}
			$this->id = $max_id_punts_clie;

			$miSQL1 = "INSERT INTO "._DB_PREFIX_."punts_clie  ";
			$miSQL2 = " (id_punts_clie, id_customer, cdTipo_clie, fcObtencionPtos, cdTipoObtencionPtos ";
			$miSQL3 = " , cdSubTipoObtencionPtos, id_order, nuPtos, nuDiasCaduc_Pto, inPtosCanjeados, fcPtosCanjedos ";
			$miSQL4 = " , inPtosDevueltos, fcPtosDevueltos, ltDescrDevueltos, id_customer_relac, id_comment, fcUpd ) ";
			$miSQL5 = " VALUES (".$this->id.",".$this->id_customer.",".$this->cdTipo_clie.",'".$this->fcObtencionPtos."' ";
			$miSQL6 = " ,".$this->cdTipoObtencionPtos.",".$this->cdSubTipoObtencionPtos.",".$this->id_order.",".$this->nuPtos.",".$this->nuDiasCaduc_Pto." ";
			$miSQL7 = " ,'".$this->inPtosCanjeados."','".$this->fcPtosCanjeados."','".$this->inPtosDevueltos."','".$this->fcPtosDevueltos."' ";
			$miSQL8 = " ,'".$this->ltDescrDevueltos."',".$this->id_customer_relac.",'".$this->id_comment."','".$this->fcUpd."' ) ";

			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5." ".$miSQL6." ".$miSQL7." ".$miSQL8;
			//$miValorParam = Db::getInstance()->getRow($miSQL);
			Db::getInstance()->execute($miSQL);
			}
		else 
			{
			echo "<BR>No se han asignado puntos. El cliente ya tiene puntos por haber comentado este articulo previamente.<BR>";
			$nuPtosAAsignar = 0;
			};


		return $nuPtosAAsignar;

	}





	// ------------------------------------------------------------------------------------------------------------------------

	/** asigna el numero de puntos canjeables por cumpleaños de un cliente*/
	public function setPtosByCumpleByCli($id_customer)
	{

		/* tipo de cliente segun su importe anual de compra */
		static $cdTipoCLI;
		

		/* 1.a) primero consultar el tipo de cliente*/		
		$cdTipoCLI = $this->getTipoCli($id_customer);

		/* buscar el parametro de num puntos segun tipo de cliente y de asignacion */
		static $nuPtosAAsignar;
		static $nuDiasCaducPtosAAsignar;
		switch  ($cdTipoCLI)
			{ case 1:
			     $nuPtosAAsignar = $this->getParamGeneral('PTO_POR_ANIVERS_CLI1');  
			     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_ANIVERS_CLI1');  
			     break;
			  case 2:
			     $nuPtosAAsignar = $this->getParamGeneral('PTO_POR_ANIVERS_CLI2');
  			     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_ANIVERS_CLI2');  
			     break;
			  case 3:
			     $nuPtosAAsignar = $this->getParamGeneral('PTO_POR_ANIVERS_CLI3');  
			     $nuDiasCaducPtosAAsignar = $this->getParamGeneral('CADUC_PTO_POR_ANIVERS_CLI3');  
			     break;
			};
		
		/* 1.b) asignar valores a la clase*/
		$this->id_customer = $id_customer;
		$this->cdTipo_clie = $cdTipoCLI;
		$this->fcObtencionPtos = date('Y-m-d 00:00:00');
		$this->cdTipoObtencionPtos = 4;	// por aniversari (cumpleaños)
		$this->cdSubTipoObtencionPtos = 0;
		$this->id_order = 0;
		$this->nuPtos = $nuPtosAAsignar;
		$this->nuDiasCaduc_Pto = $nuDiasCaducPtosAAsignar ;
		$this->inPtosCanjeados = 'N';
		$this->fcPtosCanjeados  = NULL;
		$this->inPtosDevueltos = 'N';
		$this->fcPtosDevueltos = NULL;
		$this->ltDescrDevueltos = NULL;
		$this->id_customer_relac = 'NULL';
		$this->id_comment = NULL;
		$this->fcUpd = date('Y-m-d 00:00:00');
		
		/* 1.c) comprobar que en los ultimos 11 meses no se ha asignado al cliente puntos por cumple (evitar reasignacions por error)*/	
		$nuVecesAsignPtosCumple = 0;
		$miSQL1 = "SELECT COUNT(*) valorParam";
		$miSQL2 = "FROM  "._DB_PREFIX_."punts_clie  ";
		$miSQL3 = "WHERE id_customer = ". $id_customer ." ";
		$miSQL4 = "  AND cdTipoObtencionPtos = '4' ";
		$miSQL5 = "  AND fcObtencionPtos >= DATE_SUB(NOW(), INTERVAL 11 MONTH)  ";   // revisar los ultimos 11 meses
		$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5;
		$miValorParam = Db::getInstance()->getRow($miSQL);
		$nuVecesAsignPtosCumple = $miValorParam['valorParam'];


		/* 1.d) asignar valores a la tabla de gestion de puntos (si no los tiene asignados ya) */
		if ( $nuVecesAsignPtosCumple == 0 )	
			{
			$miSQL1 = "SELECT max(id_punts_clie) valorParam ";
			$miSQL2 = "FROM  "._DB_PREFIX_."punts_clie  ";
			$miSQL  = $miSQL1." ".$miSQL2;
			$miValorParam = Db::getInstance()->getRow($miSQL);
			//if (!$miValorParam) 
			if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
				{
				$max_id_punts_clie = 1;
				}
			else
				{
				$max_id_punts_clie = $miValorParam['valorParam'] + 1;
				};
			$this->id = $max_id_punts_clie;
	
			$miSQL1 = "INSERT INTO "._DB_PREFIX_."punts_clie  ";
			$miSQL2 = " (id_punts_clie, id_customer, cdTipo_clie, fcObtencionPtos, cdTipoObtencionPtos ";
			$miSQL3 = " , cdSubTipoObtencionPtos, id_order, nuPtos, nuDiasCaduc_Pto, inPtosCanjeados, fcPtosCanjedos ";
			$miSQL4 = " , inPtosDevueltos, fcPtosDevueltos, ltDescrDevueltos, id_customer_relac, id_comment, fcUpd ) ";
			$miSQL5 = " VALUES (".$this->id.",".$this->id_customer.",".$this->cdTipo_clie.",'".$this->fcObtencionPtos."' ";
			$miSQL6 = " ,".$this->cdTipoObtencionPtos.",".$this->cdSubTipoObtencionPtos.",".$this->id_order.",".$this->nuPtos." ";
			$miSQL7 = " ,".$this->nuDiasCaduc_Pto.",'".$this->inPtosCanjeados."','".$this->fcPtosCanjeados."' ";
			$miSQL8 = " ,'".$this->inPtosDevueltos."','".$this->fcPtosDevueltos."' ";
			$miSQL9 = " ,'".$this->ltDescrDevueltos."',".$this->id_customer_relac.",'".$this->id_comment."','".$this->fcUpd."' ) ";
			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5." ".$miSQL6." ".$miSQL7." ".$miSQL8." ".$miSQL9;
			Db::getInstance()->execute($miSQL);


			//*****************************************************************************************************************
			//Enviament de email per assignació de punts per aniversari.
			//*****************************************************************************************************************

			// obtener datos del cliente 
			$miSQL1 = "SELECT firstname, lastname, email, birthday ";
			$miSQL2 = "FROM  "._DB_PREFIX_."customer  ";
			$miSQL3 = "WHERE id_customer = ". $id_customer ." ";
			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3;
			$miValorParam = Db::getInstance()->getRow($miSQL);
			$firstname = $miValorParam['firstname'];
			$lastname = $miValorParam['lastname'];
			$email = $miValorParam['email'];


			//asignacion de valores para el email 
			///$template_name = 'newsletter'; //nombre de plantilla de mail a usar (uso la generica newsletter)
			$template_name = 'newsletter_cumple'; //nombre de plantilla de mail a usar (usar la plantilla creada)
			///$id_land = Language::getIdByIso('es');     //Set the language mail template
			$id_lang = 3;     //Set the language mail template
			$subject = 'Asignacion de puntos por cumpleaños';
			$data = array(
					'{firstname}' => $firstname,
					'{lastname}' => $lastname,
					'{email}' => $email,
					'{shop_name}' => Configuration::get('PS_SHOP_NAME'),
					'{shop_url}' => Configuration::get('PS_SHOP_DOMAIN'),
					'{nuPtos}' => $this->nuPtos,
					'{nuDiasCaducPtosAAsignar}' => $nuDiasCaducPtosAAsignar,
					/* '{message}' => "Sr./Sra. ".$firstname. " ".$lastname. ", felicidades por su cumpleaños. ".
							"Como regalo le hemos otorgado ". $this->nuPtos 
							." puntos a su cuenta que podra cambiar por vales de descuento (hasta dentro de "
							.$nuDiasCaducPtosAAsignar." dias)."  */
 					'{message}' => " " //variable ya no usada directamente (se deja vacia por si alguien la invoca)
				  );
			$fileAttachment = NULL;
			//envio del email			
			$send = Mail::Send($id_lang, $template_name, Mail::l($subject, $id_lang), $data, $email, $firstname.' '.$lastname
					, NULL, NULL, $fileAttachment);
			if ($send)
			        echo "<br> OK. Email sent to customer ".$this->id_customer;
			else
			        echo "<br> ERROR sending to customer ".$this->id_customer;
			}
		else
			{
			/* cliente ya tiene puntos por cumpleaños */
			$nuPtosAAsignar = 0;
			echo "<BR>El cliente ya tiene puntos por cumpleaños asignados los ultimos 11 meses.<BR>";
			};

		return $nuPtosAAsignar;

	}



	// ------------------------------------------------------------------------------------------------------------------------

	/** asigna el numero de puntos canjeables por cada una de las promociones especiales VIGENTES para un cliente*/
	public function setPtosByPromoEspByCli($id_customer, $id_order, $importe_order , $id_paramControl)
	{


		function asignarPtosPtosByPromoEspByCli($idTipoPromoEsp, $id_customer, $id_order, $cdTipoCLI
							, $nuPtosAAsignar , $nuDiasCaducPtosAAsignar)
			{
	
			/* 2.1.c) asignar valores a la tabla de gestion de puntos */	
			$miSQL1 = "SELECT max(id_punts_clie) valorParam ";
			$miSQL2 = "FROM  "._DB_PREFIX_."punts_clie  ";
			$miSQL  = $miSQL1." ".$miSQL2;
			$miValorParam = Db::getInstance()->getRow($miSQL);
			//if (!$miValorParam) 
			if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
				{
				$max_id_punts_clie = 1;
				}
			else
				{
				$max_id_punts_clie = $miValorParam['valorParam'] + 1;
				};
	
			$miSQL1 = "INSERT INTO "._DB_PREFIX_."punts_clie  ";
			$miSQL2 = " (id_punts_clie, id_customer, cdTipo_clie, fcObtencionPtos, cdTipoObtencionPtos ";
			$miSQL3 = " , cdSubTipoObtencionPtos, id_order, nuPtos, nuDiasCaduc_Pto, inPtosCanjeados, fcPtosCanjedos ";
			$miSQL4 = " , inPtosDevueltos, fcPtosDevueltos, ltDescrDevueltos, id_customer_relac, id_comment, fcUpd ) ";
			$miSQL5 = " VALUES (".$max_id_punts_clie.",".$id_customer.",".$cdTipoCLI.",'". date('Y-m-d 00:00:00') ."' ";
			$miSQL6 = " , 5 ,".$idTipoPromoEsp.",".$id_order.",".$nuPtosAAsignar.",".$nuDiasCaducPtosAAsignar." ";
			$miSQL7 = " ,'N', NULL ,'N', NULL , NULL, NULL, NULL ,'". date('Y-m-d 00:00:00') ."' ) ";
			$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5." ".$miSQL6." ".$miSQL7;
			//////echo "<hr><hr>--->SQL de la promocion especial ". $idTipoPromoEsp .": ". $miSQL ."<HR>";
			Db::getInstance()->execute($miSQL);

			return	$max_id_punts_clie;  //identificador de los puntos asignados  			
			}



		/* tipo de cliente segun su importe anual de compra */
		static $cdTipoCLI;
		

		static $nuPtosAAsignar;
		static $nuPtosAAsignarTotalPromos;
		static $nuDiasCaducPtosAAsignar;
		static $inCumpleCondPromo;

		/* 1) primero el tipo de cliente */		
		$cdTipoCLI = $this->getTipoCli($id_customer);

		/* 2) buscar todas las promociones especiales VIGENTES */
		$nuPtosAAsignar = 0;
		$nuPtosAAsignarTotalPromos = 0;
		$miSQL1 = "SELECT id_punts_promo_esp_param, id_tipo_promo_esp_param, fcIni, fcFin ";
		$miSQL2 = ", cdTipoValorControl, ltValorControlNUM,ltValorControlSTR,ltValorControlFEC ";
		$miSQL3 = ",nuPto_CLI1, nuPto_CLI2, nuPto_CLI3,	nuDiasCaduc_Pto_CLI1, nuDiasCaduc_Pto_CLI2, nuDiasCaduc_Pto_CLI3, fcUpd ";
		$miSQL4 = "FROM  "._DB_PREFIX_."punts_promo_esp_param ";
		$miSQL5 = "WHERE  NOW()  BETWEEN  fcIni  AND fcFin ";
		$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5;

		// bucle para recorrer las promociones vigentes
		$regDevuelto = Db::getInstance()->executeS($miSQL);
		foreach ($regDevuelto as $fila)
			{
			/// echo "<br>---> PROMOC.ESP num.". $fila['id_punts_promo_esp_param'];   ///solo para PRUEBAS

			switch  ($cdTipoCLI)
			{ case 1:
			     $nuPtosAAsignar = $fila['nuPto_CLI1'];  /* nota: en general es el numero de ptos a asignar, 
								pero en algunas promociones puede ser el valor (factor) multiplicador a aplicar */  
			     $nuDiasCaducPtosAAsignar = $fila['nuDiasCaduc_Pto_CLI1'];  
			     break;
			  case 2:
			     $nuPtosAAsignar = $fila['nuPto_CLI2'];  /* nota: en general es el numero de ptos a asignar, 
								pero en algunas promociones puede ser el valor (factor) multiplicador a aplicar */
  			     $nuDiasCaducPtosAAsignar = $fila['nuDiasCaduc_Pto_CLI2'];  
			     break;
			  case 3:
			     $nuPtosAAsignar = $fila['nuPto_CLI3'];  /* nota: en general es el numero de ptos a asignar, 
								pero en algunas promociones puede ser el valor (factor) multiplicador a aplicar */
			     $nuDiasCaducPtosAAsignar = $fila['nuDiasCaduc_Pto_CLI3'];  
			     break;
			};


			/* asignar valores a la clase */
			$this->id_customer = $id_customer;
			$this->cdTipo_clie = $cdTipoCLI;
			$this->fcObtencionPtos = date('Y-m-d 00:00:00');
			$this->cdTipoObtencionPtos = 5;	// por promocion especial
			$this->cdSubTipoObtencionPtos = $fila['id_tipo_promo_esp_param']; // tipo de promocion especial  
			$this->id_order = 0;
			///$this->nuPtos = $nuPtosAAsignar;  ---> debe hacerse despues en cada tipo de promocion
			$this->nuDiasCaduc_Pto = $nuDiasCaducPtosAAsignar ;
			$this->inPtosCanjeados = 'N';
			$this->fcPtosCanjeados  = NULL;
			$this->inPtosDevueltos = 'N';
			$this->fcPtosDevueltos = NULL;
			$this->ltDescrDevueltos = NULL;
			$this->id_customer_relac = 'NULL';
			$this->id_comment = NULL;
			$this->fcUpd = date('Y-m-d 00:00:00');


			//PROMOCION ESPECIAL TIPO 1: promocion por compra minima - asignacion directa de punts */
			if ( $fila['id_tipo_promo_esp_param'] == 1 )
				{
				/* comprobar si se cumple la condicion de la promocion y, en tal caso llamar a la funcion de asignacion de puntos */
				$inCumpleCondPromo = false;
				$paramControlPromoEsp = $fila['ltValorControlNUM'];  /* en este caso es un importe minimo de compra 
											el valor a controlar en esta promocion especial*/
				$valorRealControlPromoEsp = $importe_order;	/* en este caso el valor a revisar es el importe de la compra */
	
				if ( $valorRealControlPromoEsp >= $paramControlPromoEsp )
					{
					$inCumpleCondPromo = true;
					};
	
				if ( $inCumpleCondPromo == true )
					{
					// cumple la condicion de la promocion: asignacion directa de los puntos que corresponda
					$this->nuPtos = $nuPtosAAsignar;
					///echo "ptos compra=". $id_paramControl ." Ptos A Asignar directamente promo esp=".$this->nuPtos."<br>";
					$this->id = asignarPtosPtosByPromoEspByCli( $fila['id_tipo_promo_esp_param'] , $id_customer
										, $id_order, $cdTipoCLI	, $nuPtosAAsignar , $nuDiasCaducPtosAAsignar);
					$nuPtosAAsignarTotalPromos = $nuPtosAAsignarTotalPromos + $nuPtosAAsignar;
					};
				};


			//PROMOCION ESPECIAL TIPO 2: promocion por marca de zapatos - asignacion directa de punts */
			if ( $fila['id_tipo_promo_esp_param'] == 2 )
				{
				/* comprobar si se cumple la condicion de la promocion y, en tal caso llamar a la funcion de asignacion de puntos */
				$inCumpleCondPromo = false;
				$paramControlPromoEsp = strtoupper($fila['ltValorControlSTR']);  /* en este caso es una marca concreta 
											 	 el valor a controlar en esta promocion especial*/
	
				/* contar el numero de items comprados de esa marca (si los hay)*/	
				$miSQL1 = "SELECT SUM(product_quantity) valorParam, SUM(product_price) product_price_marca ";
				$miSQL2 = "FROM  "._DB_PREFIX_."order_detail  ";
				$miSQL3 = "WHERE id_order = ". $id_order ." ";
				$miSQL4 = "  AND UPPER(product_name) like '%". $paramControlPromoEsp ."%'  ";
				$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4;
				///echo "<hr><hr>--->MI SQL promo2: ". $miSQL ."<HR>";
				$miValorParam = Db::getInstance()->getRow($miSQL);
				//if (!$miValorParam) 
				if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
					{
					$valorRealControlPromoEsp = 0;
					}
				else
					{
					$valorRealControlPromoEsp = $miValorParam['valorParam'];  /* en este caso el valor a revisar 
													es el numero de productos 
											  		de esa marca comprados */
					};
				if ( $valorRealControlPromoEsp >= 1 )
					{
					$inCumpleCondPromo = true;
					};
	
				if ( $inCumpleCondPromo == true )
					{
					// cumple la condicion de la promocion: asignacion directa de los puntos que corresponda
					$this->nuPtos = $nuPtosAAsignar;
					////echo "ptos compra=". $id_paramControl ." Ptos A Asignar directamente promo esp=".$this->nuPtos."<br>";
					$this->id = asignarPtosPtosByPromoEspByCli( $fila['id_tipo_promo_esp_param'] , $id_customer
									, $id_order, $cdTipoCLI	, $nuPtosAAsignar , $nuDiasCaducPtosAAsignar);
					$nuPtosAAsignarTotalPromos = $nuPtosAAsignarTotalPromos + $nuPtosAAsignar;
					};
	
				};


			//PROMOCION ESPECIAL TIPO 3: promocion por modelo de zapatos - asignacion directa de punts */
			if ( $fila['id_tipo_promo_esp_param'] == 3 )
				{
				/* comprobar si se cumple la condicion de la promocion y, en tal caso llamar a la funcion de asignacion de puntos */
				$inCumpleCondPromo = false;
				$paramControlPromoEsp = strtoupper($fila['ltValorControlSTR']);  /* en este caso es un modelo concreto 
											 	 el valor a controlar en esta promocion especial*/
	
				/* contar el numero de items comprados de ese modelo (si los hay)*/	
				$miSQL1 = "SELECT SUM(product_quantity) valorParam, SUM(product_price) product_price_marca ";
				$miSQL2 = "FROM  "._DB_PREFIX_."order_detail  ";
				$miSQL3 = "WHERE id_order = ". $id_order ." ";
				$miSQL4 = "  AND UPPER(product_name) like '%". $paramControlPromoEsp ."%'  ";
				$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4;
				///echo "<hr><hr>--->MI SQL promo3: ". $miSQL ."<HR>";
				$miValorParam = Db::getInstance()->getRow($miSQL);
				//if (!$miValorParam) 
				if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
					{
					$valorRealControlPromoEsp = 0;
					}
				else
					{
					$valorRealControlPromoEsp = $miValorParam['valorParam'];  /* en este caso el valor a revisar 
													es el numero de productos 
											  		de ese modelo comprados */
					};
				if ( $valorRealControlPromoEsp >= 1 )
					{
					$inCumpleCondPromo = true;
					};
	
				if ( $inCumpleCondPromo == true )
					{
					// cumple la condicion de la promocion: asignacion directa de los puntos que corresponda
					$this->nuPtos = $nuPtosAAsignar;
					////echo "ptos compra=". $id_paramControl ." Ptos A Asignar directamente promo esp=".$this->nuPtos."<br>";
					$this->id = asignarPtosPtosByPromoEspByCli( $fila['id_tipo_promo_esp_param'] , $id_customer
									, $id_order, $cdTipoCLI	, $nuPtosAAsignar , $nuDiasCaducPtosAAsignar);
					$nuPtosAAsignarTotalPromos = $nuPtosAAsignarTotalPromos + $nuPtosAAsignar;
					};
	
				};


			//PROMOCION ESPECIAL TIPO 4: promocion por compra minima - asignacion por factor multiplicador de los punts de la compra 
			if ( $fila['id_tipo_promo_esp_param'] == 4 )
				{
				/* comprobar si se cumple la condicion de la promocion y, en tal caso llamar a la funcion de asignacion de puntos */
				$inCumpleCondPromo = false;
				$paramControlPromoEsp = $fila['ltValorControlNUM'];  /* en este caso es un importe minimo de compra 
											el valor a controlar en esta promocion especial*/
				$valorRealControlPromoEsp = $importe_order;	/* en este caso el valor a revisar es el importe de la compra */
	
				if ( $valorRealControlPromoEsp >= $paramControlPromoEsp )
					{
					$inCumpleCondPromo = true;
					};
	
				if ( $inCumpleCondPromo == true )
					{
					/* cumple la condicion de la promocion: asignacion POR FACTOR MULTIPLICADOR de los puntos (en $nuPtosAAsignar)
					que haya conseguido en la compra realizada (pasados por parametro en $id_paramControl) */
					///$this->nuPtos = $nuPtosAAsignar * $id_paramControl ;
					$this->nuPtos = ( $nuPtosAAsignar * $id_paramControl ) - $id_paramControl;    
					///echo "ptos compra=". $id_paramControl ." factor=". $nuPtosAAsignar ." ptos promo esp=".$this->nuPtos."<br>";
					$this->id = asignarPtosPtosByPromoEspByCli( $fila['id_tipo_promo_esp_param'] , $id_customer
										, $id_order, $cdTipoCLI	, $nuPtosAAsignar , $nuDiasCaducPtosAAsignar);
					$nuPtosAAsignarTotalPromos = $nuPtosAAsignarTotalPromos + $nuPtosAAsignar;
					};
				};


			//PROMOCION ESPECIAL TIPO promocion por marca de zapatos - asignacion por factor multiplicador de los punts de la compra 
			if ( $fila['id_tipo_promo_esp_param'] == 5 )
				{
				/* comprobar si se cumple la condicion de la promocion y, en tal caso llamar a la funcion de asignacion de puntos */
				$inCumpleCondPromo = false;
				$paramControlPromoEsp = strtoupper($fila['ltValorControlSTR']);  /* en este caso es una marca concreta 
											 	 el valor a controlar en esta promocion especial*/
	
				/* contar el numero de items comprados de esa marca (si los hay)*/	
				$miSQL1 = "SELECT SUM(product_quantity) valorParam, SUM(product_price) product_price_marca ";
				$miSQL2 = "FROM  "._DB_PREFIX_."order_detail  ";
				$miSQL3 = "WHERE id_order = ". $id_order ." ";
				$miSQL4 = "  AND UPPER(product_name) like '%". $paramControlPromoEsp ."%'  ";
				$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4;
				///echo "<hr><hr>--->MI SQL promo5: ". $miSQL ."<HR>";
				$miValorParam = Db::getInstance()->getRow($miSQL);
				//if (!$miValorParam) 
				if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
					{
					$valorRealControlPromoEsp = 0;
					}
				else
					{
					$valorRealControlPromoEsp = $miValorParam['valorParam'];  /* en este caso el valor a revisar 
													es el numero de productos 
													  de esa marca comprados */
					};
				if ( $valorRealControlPromoEsp >= 1 )
					{
					$inCumpleCondPromo = true;
					};
	
				if ( $inCumpleCondPromo == true )
					{
					/* cumple la condicion de la promocion: asignacion POR FACTOR MULTIPLICADOR de los puntos (en $nuPtosAAsignar)
					que haya conseguido en la compra realizada (pasados por parametro en $id_paramControl) */
					///$this->nuPtos = $nuPtosAAsignar * $id_paramControl ;
					$this->nuPtos = ( $nuPtosAAsignar * $id_paramControl ) - $id_paramControl;    
					///echo "ptos compra=". $id_paramControl ." factor=". $nuPtosAAsignar ." ptos promo esp=".$this->nuPtos."<br>";
					$this->id = asignarPtosPtosByPromoEspByCli( $fila['id_tipo_promo_esp_param'] , $id_customer
										, $id_order, $cdTipoCLI	, $nuPtosAAsignar , $nuDiasCaducPtosAAsignar);
					$nuPtosAAsignarTotalPromos = $nuPtosAAsignarTotalPromos + $nuPtosAAsignar;
					};
	
				};


			//PROMOCION ESPECIAL TIPO promocion por modelo de zapatos - asignacion por factor multiplicador de los punts de la compra 
			if ( $fila['id_tipo_promo_esp_param'] == 6 )
				{
				/* comprobar si se cumple la condicion de la promocion y, en tal caso llamar a la funcion de asignacion de puntos */
				$inCumpleCondPromo = false;
				$paramControlPromoEsp = strtoupper($fila['ltValorControlSTR']);  /* en este caso es un modelo concreto 
											 	 el valor a controlar en esta promocion especial*/
	
				/* contar el numero de items comprados de ese modelo (si los hay)*/	
				$miSQL1 = "SELECT SUM(product_quantity) valorParam, SUM(product_price) product_price_marca ";
				$miSQL2 = "FROM  "._DB_PREFIX_."order_detail  ";
				$miSQL3 = "WHERE id_order = ". $id_order ." ";
				$miSQL4 = "  AND UPPER(product_name) like '%". $paramControlPromoEsp ."%'  ";
				$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4;
				///echo "<hr><hr>--->MI SQL promo6: ". $miSQL ."<HR>";
				$miValorParam = Db::getInstance()->getRow($miSQL);
				//if (!$miValorParam) 
				if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
					{
					$valorRealControlPromoEsp = 0;
					}
				else
					{
					$valorRealControlPromoEsp = $miValorParam['valorParam'];  /* en este caso el valor a revisar 
													es el numero de productos 
											  		de ese modelo comprados */
					};
				if ( $valorRealControlPromoEsp >= 1 )
					{
					$inCumpleCondPromo = true;
					};
	
				if ( $inCumpleCondPromo == true )
					{
					/* cumple la condicion de la promocion: asignacion POR FACTOR MULTIPLICADOR de los puntos (en $nuPtosAAsignar)
					que haya conseguido en la compra realizada (pasados por parametro en $id_paramControl) */
					///$this->nuPtos = $nuPtosAAsignar * $id_paramControl ;
					$this->nuPtos = ( $nuPtosAAsignar * $id_paramControl ) - $id_paramControl;    
					///echo "ptos compra=". $id_paramControl ." factor=". $nuPtosAAsignar ." ptos promo esp=".$this->nuPtos."<br>";
					$this->id = asignarPtosPtosByPromoEspByCli( $fila['id_tipo_promo_esp_param'] , $id_customer
										, $id_order, $cdTipoCLI	, $nuPtosAAsignar , $nuDiasCaducPtosAAsignar);
					$nuPtosAAsignarTotalPromos = $nuPtosAAsignarTotalPromos + $nuPtosAAsignar;
					};
	
				};


			/* fin del bucle de tratamiento de promociones especiales vigentes */
			};

		return $nuPtosAAsignarTotalPromos;

	}





	// ------------------------------------------------------------------------------------------------------------------------

	/** realiza el canje de un array de puntos seleccionados por el cliente, cambiándolos por un vale de descuento */
	public function setCanjeaPtosByDiscounts($id_cliente,$array_id_puntos)
	{
		static $nuPtosTotalACanjear;
		static $importeTotalACanjear;
		static $importeCanje_PU_EU;  /*'Conversion de 1 Punt a euros'*/
		static $cadenaPuntsClie_a_canjear; 
	
		$nuPtosTotalACanjear = 0;
		//////echo "<br><hr><hr><hr>---> setCanjeaPtosByDiscounts: del cliente ". $id_cliente ;

		//0) comprobar que el cliente está informado
		if ( strlen($id_cliente) <=0 )
			{
			echo "<HR>No se ha informado el cliente a actualizar<HR>";
			return 0;
			}
		

		//1) obtener el valor de canje de 1 punto en euros
		$importeCanje_PU_EU = PuntsGestion::getParamGeneral('CONV_PU_EU'); /*'Conversion de 1 Punt a euros'*/

		//2) recorrer la lista de items con puntos que el cliente quiere canjear y preparar la string necesariar para la query para hacerlo
		$i = 0;
		$cadenaPuntsClie_a_canjear = "";
		foreach ($array_id_puntos as $key ) 
			{
			//if ( $i == 0 ) ---> es el identificador del cliente
			if ( ($i > 0) && ($i == 1) )
				{
				$cadenaPuntsClie_a_canjear = $array_id_puntos[$i];
				};
			if ( ($i > 0) && ($i > 1) )
				{
				$cadenaPuntsClie_a_canjear = $cadenaPuntsClie_a_canjear .",".$array_id_puntos[$i];
				};
			////echo "<br>---> elemento ". $i ." valor = ".$array_id_puntos[$i];
			$i = $i + 1;
			};

		//3) ejecutar la query de actualizacion de puntos usados en el canje
		$miSQL1 = "UPDATE "._DB_PREFIX_."punts_clie  ";
		$miSQL2 = " SET inPtosCanjeados = 'S' ";
		$miSQL3 = "   , fcPtosCanjedos =  NOW() ";
		$miSQL4 = "   , fcUpd =  NOW() ";
		$miSQL5 = " WHERE id_customer = ". $id_cliente ." AND id_punts_clie IN (". $cadenaPuntsClie_a_canjear .") ";
		$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3." ".$miSQL4." ".$miSQL5;
		// ejecutar la query
		///echo "<hr><br>--> LA QUERY1: ".$miSQL."<br><hr>"; 		
		Db::getInstance()->execute($miSQL);

	

		//4) Obtener valores de parametros totales a usar:
		
		//4.1) Obtener el importe total de puntos a canjear
		$miSQL1 = "SELECT SUM(nuPtos) valorParam ";
		$miSQL2 = "FROM  "._DB_PREFIX_."punts_clie  ";
		$miSQL3 = " WHERE id_customer = ". $id_cliente ." AND id_punts_clie IN (". $cadenaPuntsClie_a_canjear .") ";
		$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3;
		///echo "<hr><br>--> LA QUERY2: ".$miSQL."<br><hr>";
		$miValorParam = Db::getInstance()->getRow($miSQL);
		//if (!$miValorParam) 
		if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
			{
			$nuPtosTotalACanjear = 0;
			}
		else
			{
			$nuPtosTotalACanjear = $miValorParam['valorParam'];
			};
		$importeTotalACanjear = $nuPtosTotalACanjear * $importeCanje_PU_EU; 


		//4.2) Obtener el ultimo id_discount del cliente
		$miSQL1 = "SELECT MAX(id_discount) valorParam ";
		$miSQL2 = "FROM  "._DB_PREFIX_."discount  ";
		$miSQL3 = " WHERE id_customer = ". $id_cliente ." ";
		$miSQL  = $miSQL1." ".$miSQL2." ".$miSQL3;
		///echo "<hr><br>--> LA QUERY3: ".$miSQL."<br><hr>";
		$miValorParam = Db::getInstance()->getRow($miSQL);
		//if (!$miValorParam) 
		if ( !$miValorParam || !$miValorParam['valorParam'] || is_null($miValorParam['valorParam']) )
			{
			$id_discount_last = 1;
			}
		else
			{
			$id_discount_last = $miValorParam['valorParam'] + 1;
			};
		


		//5) Finalmente generar el vale de descuento con el importe total correspondiente a los puntos canjeados
		//y generar el comentario correspondiente para el cliente
		////echo "<HR>Se ha realizado el canje de los puntos seleccionados (". $nuPtosTotalACanjear .").";
		////echo "<BR>Acaba de conseguir un vale de descuento por importe de ". $importeTotalACanjear ." euros.";
		
		///crear objeto de vale de descuento, rellenar sus campos y ejecutar la inclusion
		$valeDescuento = new Discount();

		$valeDescuento->id_discount_type = 2;		// 1-descuento de %, 2-descuento de Euros en el pedido, 3-gastos de envio gratis
		$valeDescuento->id_customer = $id_cliente;
		$valeDescuento->id_group = NULL;

		//código identificador del vale de descuento que el cliente introducirá en la cesta de la compra para aplicar el descuento.
		$valeDescuento->name = 'PTO-'.$id_cliente.'-'.$id_discount_last; 

		//segun el tipo de descuento este valor será un % o un importe (en este caso = importe)
		$valeDescuento->value = $importeTotalACanjear;	
		$valeDescuento->id_currency = '1';  //euro

		$valeDescuento->quantity = 1;
		$valeDescuento->quantity_per_user = 1;
		$valeDescuento->cumulable = 1;
		$valeDescuento->cumulable_reduction = 1;
		$valeDescuento->behavior_not_exhausted = 1;
		$valeDescuento->date_from = date('Y-m-d H:i:s', time());
		//$valeDescuento->date_to = NULL;
		$valeDescuento->date_to = date('Y-m-d H:i:s', time() + (3600 * 24 * 365.25)); /* 1 year de validez */
		$valeDescuento->minimal = 0;
		$valeDescuento->include_tax = 0;
		$valeDescuento->active = 1;
		$valeDescuento->cart_display = 0;
		$valeDescuento->date_add = date('Y-m-d 00:00:00');
		$valeDescuento->date_upd = date('Y-m-d 00:00:00');		
		$resultado = $valeDescuento->add();
		////echo "<HR>--->REsultado ".$resultado;

		return $nuPtosTotalACanjear;
	}





	// ------------------------------------------------------------------------------------------------------------------------

	/** desasigna el numero de puntos debido a DEVOLUCION de un cliente*/
	public function setDevolPtosByCompraByCli($id_customer, $id_order_devol, $importe_devol, $id_order)
	{

		/* datos del cliente */
		static $cdTipoCLI;
		static $nuPtosADesasignar;		

		/* actualmente se hace a mano desde la parte del backoffice:  Clientes > Gestion Puntos */
		/* por eso este metodo esta vacio pues no se ha necesitado */		


		// .......

		return $nuPtosADesasignar;

	}





}
